/***************************************************************************/
/* 	This code is part of X-toolkit widget library called Nws 	   */
/*	Copyright (c) 1997,1998,1999 Ondrejicka Stefan			   */
/*	(ondrej@idata.sk)						   */
/*	Distributed under GPL 2 or later				   */
/***************************************************************************/

#ifndef _CheckButtonP_H_
#define _CheckButtonP_H_

#include	<Nws/BaseP.h>
#include	<Nws/CheckButton.h>
#include	<Nws/cvt.h>

typedef struct {
	int empty;
} CheckButtonClassPart;

typedef struct _CheckButtonClassRec {
	CoreClassPart		core_class;
	BaseClassPart		base_class;
	CheckButtonClassPart	checkButton_class;
} CheckButtonClassRec;

extern CheckButtonClassRec checkButtonClassRec;

typedef struct {
	/* resources */
	Boolean		on;
	XtCallbackList	set;
	XtCallbackList	reset;
	XtCallbackList	switch_it;
	XFontStruct     * font;
	int		spacing;
	String		label;
	int		type;
	Boolean		proportional;
	Boolean		auto_switch;
	/* private */
	Icon		* i_on , * i_off;
	GC		text_gc;
	Boolean		entered;
} CheckButtonPart;

typedef struct _CheckButtonRec {
	CorePart		core;
	BasePart		base;
	CheckButtonPart		checkButton;
} CheckButtonRec;
	
#endif
