/***************************************************************************/
/* 	This code is part of X-toolkit widget library called Nws 	   */
/*	Copyright (c) 1997,1998,1999 Ondrejicka Stefan			   */
/*	(ondrej@idata.sk)						   */
/*	Distributed under GPL 2 or later				   */
/***************************************************************************/

#ifndef _FileSelector_H_
#define _FileSelector_H_

#include <Nws/Row.h>

#define XtCok_button		1
#define XtCcancel_button	2
#define	XtCapply_button		3
#define XtChelp_button		4
#define XtCrescan_button	5
#define XtCfile_list		6
#define XtCdir_list		7
#define XtCfilter_entry		8
#define XtCdir_entry		9
#define XtCfile_entry		10
#define XtCbutton_column	11

#ifndef XtNfilter
#define XtNfilter		"filter"
#endif
#ifndef XtCFilter
#define XtCFilter		"Filter"
#endif

#ifndef XtNfile
#define XtNfile			"file"
#endif
#ifndef XtCFile
#define XtCFile			"File"
#endif

#ifndef XtNdir
#define XtNdir			"dir"
#endif
#ifndef XtCDir
#define XtCDir			"Dir"
#endif

#ifndef XtNspacing
#define XtNspacing		"spacing"
#endif
#ifndef XtCSpacing
#define XtCSpacing		"Spacing"
#endif

#ifndef XtNok_button_cb
#define XtNok_button_cb		"ok_button_cb"
#endif
#ifndef XtCOk_button_cb
#define XtCOk_button_cb		"Ok_button_cb"
#endif

#ifndef XtNcancel_button_cb
#define XtNcancel_button_cb	"cancel_button_cb"
#endif
#ifndef XtCCancel_button_cb
#define XtCCancel_button_cb	"Cancel_button_cb"
#endif

#ifndef XtNapply_button_cb
#define XtNapply_button_cb	"apply_button_cb"
#endif
#ifndef XtCApply_button_cb
#define XtCApply_button_cb	"Apply_button_cb"
#endif

#ifndef XtNhelp_button_cb
#define XtNhelp_button_cb	"help_button_cb"
#endif
#ifndef XtCHelp_button_cb
#define XtCHelp_button_cb	"Help_button_cb"
#endif

#ifndef XtNdirsel
#define XtNdirsel		"dirsel"
#endif
#ifndef XtCDirsel
#define XtCDirsel		"Dirsel"
#endif


#ifndef XtNfilter_label
#define XtNfilter_label		"filter_label"
#endif
#ifndef XtCFilter_label
#define XtCFilter_label		"Filter_label"
#endif

#ifndef XtNfile_label
#define XtNfile_label		"file_label"
#endif
#ifndef XtCFile_label
#define XtCFile_label		"File_label"
#endif

#ifndef XtNdir_label
#define XtNdir_label		"dir_label"
#endif
#ifndef XtCDir_label
#define XtCDir_label		"Dir_label"
#endif

#ifndef XtNok_label
#define XtNok_label		"ok_label"
#endif
#ifndef XtCOk_label
#define XtCOk_label		"Ok_label"
#endif

#ifndef XtNapply_label
#define XtNapply_label		"apply_label"
#endif
#ifndef XtCApply_label
#define XtCApply_label		"apply_label"
#endif

#ifndef XtNrescan_label
#define XtNrescan_label		"rescan_label"
#endif
#ifndef XtCRescan_label
#define XtCRescan_label		"Rescan_label"
#endif

#ifndef XtNhelp_label
#define XtNhelp_label		"help_label"
#endif
#ifndef XtCHelp_label
#define XtCHelp_label		"Help_label"
#endif

#ifndef XtNcancel_label
#define XtNcancel_label		"cancel_label"
#endif
#ifndef XtCCancel_label
#define XtCCancel_label		"Cancel_label"
#endif


extern WidgetClass	fileSelWidgetClass;

typedef struct _FileSelClassRec		*FileSelWidgetClass;
typedef struct _FileSelRec		*FileSelWidget;

#if NeedFunctionPrototypes
extern Widget GetFileSelWidget(Widget , int);
extern void CreateFSShell(String , String , Widget , Widget * , Widget *);
extern void CreateDSShell(String , String , Widget , Widget * , Widget *);
#else
extern Widget GetFileSelWidget();
extern void CreateFSShell();
extern void CreateDSShell();
#endif

#endif
