/***************************************************************************/
/* 	This code is part of X-toolkit widget library called Nws 	   */
/*	Copyright (c) 1997,1998,1999 Ondrejicka Stefan			   */
/*	(ondrej@idata.sk)						   */
/*	Distributed under GPL 2 or later				   */
/***************************************************************************/

#ifndef _List_H_
#define _List_H_

#include	<Nws/Col.h>
#include	<Nws/cvt.h>

#ifndef XtNfont
#define XtNfont		"font"
#endif
#ifndef XtCFont
#define XtCFont		"Font"
#endif

#ifndef XtNnum_entry
#define XtNnum_entry	"num_entry"
#endif
#ifndef XtCNum_entry
#define XtCNum_entry	"Num_entry"
#endif

#ifndef XtNnum_selected
#define XtNnum_selected	"num_selected"
#endif
#ifndef XtCNum_selected
#define XtCNum_selected	"Num_selected"
#endif

#ifndef XtNselect_cb
#define XtNselect_cb	"select_cb"
#endif
#ifndef XtCSelect_cb
#define XtCSelect_cb	"Select_cb"
#endif

#ifndef XtNselect_changed_cb
#define XtNselect_changed_cb	"select_changed_cb"
#endif
#ifndef XtCSelect_changed_cb
#define XtCSelect_changed_cb	"Select_changed_cb"
#endif

#ifndef XtNselected_fg
#define XtNselected_fg	"selected_fg"
#endif
#ifndef XtCSelected_fg
#define XtCSelected_fg	"Selected_fg"
#endif

#ifndef XtNselected_bg
#define XtNselected_bg	"selected_bg"
#endif
#ifndef XtCSelected_bg
#define XtCSelected_bg	"Selected_bg"
#endif

#ifndef XtNlist
#define XtNlist		"list"
#endif
#ifndef XtCList
#define XtCList		"List"
#endif

#ifndef XtNselected_list
#define XtNselected_list	"selected_list"
#endif
#ifndef XtCSelected_list
#define XtCSelected_list	"Selected_list"
#endif


extern WidgetClass	listWidgetClass;

typedef struct _ListClassRec	*ListWidgetClass;
typedef struct _ListRec		*ListWidget;

#if  NeedFunctionPrototypes
extern void ListChange(Widget , ListStruct * , int , Boolean);
extern void FreeList(ListStruct * , int);
extern ListStruct * SetSelected(Widget , int);
extern int ListAppendItems(Widget , ListStruct * , int);
extern ListStruct * ListGetSelected(Widget);
extern void DeleteListItem(Widget , int);
#else
extern void ListChange();
extern void FreeList();
extern ListStruct *SetSelected();
extern int ListAppendItems();
extern ListStruct * ListGetSelected();
extern void DeleteListItem();
#endif

#endif
