/***************************************************************************/
/* 	This code is part of X-toolkit widget library called Nws 	   */
/*	Copyright (c) 1997,1998,1999 Ondrejicka Stefan			   */
/*	(ondrej@idata.sk)						   */
/*	Distributed under GPL 2 or later				   */
/***************************************************************************/

#ifndef _LogP_H_
#define _LogP_H_

#include <Nws/BaseP.h>
#include <Nws/Log.h>

typedef struct _StrList {
	char		*entry;
	struct _StrList *next;
} StrList;

typedef struct {
	char	empty;
} LogClassPart;

typedef struct _LogClassRec {
        CoreClassPart           core_class;
        BaseClassPart		base_class;
        LogClassPart     	log_class;
} LogClassRec;

extern LogClassRec logClassRec;


typedef struct {
	/* resources */
	int		spacing;
        Pixel           selected_fg;
        Pixel           selected_bg;
        XFontStruct	*font;
	int		maxlines;
	Boolean		bottom_grav;
	/* private */
        StrList		*first;
        StrList		*last;
        int		numlines;
        int		topx;
        int 		topy;
	GC		gc;
	Boolean		scrolled;
} LogPart;

typedef struct _LogRec {
        CorePart        core;
        BasePart	base;
        LogPart	log;
} LogRec;

#endif
