/***************************************************************************/
/* 	This code is part of X-toolkit widget library called Nws 	   */
/*	Copyright (c) 1997,1998,1999 Ondrejicka Stefan			   */
/*	(ondrej@idata.sk)						   */
/*	Distributed under GPL 2 or later				   */
/***************************************************************************/

#ifndef _MBButtonP_H_
#define _MBButtonP_H_

#include	<Nws/LabelMEP.h>
#include	<Nws/MBButton.h>

#if NeedFunctionPrototypes
typedef	void (*popdown_menu_Proc) (Widget);
#else
typedef void (*popdown_menu_Proc) ();
#endif

#define XtInheritPopdownMenu ((popdown_menu_Proc) _XtInherit)

typedef struct {
	popdown_menu_Proc	popdown_menu;	
} MBButtonClassPart;

typedef struct _MBButtonClassRec {
	RectObjClassPart        rect_class;
	BaseMEClassPart         baseME_class;
	LabelMEClassPart        labelME_class;
	MBButtonClassPart	mBButton_class;
} MBButtonClassRec;

extern MBButtonClassRec mBButtonClassRec;

typedef struct {
	/* resources */
	String		menu_name;
	/* private */
	Widget		menu;
} MBButtonPart;

typedef struct _MBButtonRec {
	ObjectPart              object;
	RectObjPart             rectangle;
	BaseMEPart              baseME;
	LabelMEPart             labelME;
	MBButtonPart		mBButton;
} MBButtonRec;

#endif
