/***************************************************************************/
/* 	This code is part of X-toolkit widget library called Nws 	   */
/*	Copyright (c) 1997,1998,1999 Ondrejicka Stefan			   */
/*	(ondrej@idata.sk)						   */
/*	Distributed under GPL 2 or later				   */
/***************************************************************************/

#ifndef _MultiColP_H_
#define _MultiColP_H_

#include <Nws/BaseConstP.h>
#include <Nws/MultiCol.h>
#include <Nws/dimdefP.h>

typedef struct {
	char	empty;
} MultiColClassPart;

typedef struct _MultiColClassRec {
	CoreClassPart		core_class;
	CompositeClassPart	composite_class;
	ConstraintClassPart	constraint_class;
	BaseConstClassPart	baseConst_class;
	MultiColClassPart	multiCol_class;
} MultiColClassRec;

extern MultiColClassRec multiColClassRec;

typedef struct _MultiColPart {
	/* public resources */
	int	spacing;
	/* private */
} MultiColPart;

typedef struct _MultiColRec {
	CorePart	core;
	CompositePart	composite;
	ConstraintPart	constraint;
	BaseConstPart	baseConst;
	MultiColPart	multiCol;
} MultiColRec;

typedef struct _MultiColConstraintsPart {
	int	id;
} MultiColConstraintsPart;

typedef struct _MultiColConstraintsRec {
	MultiColConstraintsPart		multiCol;
} MultiColConstraintsRec, *MultiColConstraints;

#endif
