/***************************************************************************/
/* 	This code is part of X-toolkit widget library called Nws 	   */
/*	Copyright (c) 1997,1998,1999 Ondrejicka Stefan			   */
/*	(ondrej@idata.sk)						   */
/*	Distributed under GPL 2 or later				   */
/***************************************************************************/

#ifndef _ScrollWinP_H_
#define _ScrollWinP_H_

#include	<Nws/BaseCompP.h>
#include	<Nws/ScrollWin.h>

typedef struct {
	char	empty;
} ScrollWinClassPart;

typedef struct _ScrollWinClassRec {
	CoreClassPart		core_class;
	CompositeClassPart	composite_class;
	BaseCompClassPart	baseComp_class;
	ScrollWinClassPart	scrollWin_class;
} ScrollWinClassRec;

extern ScrollWinClassRec scrollWinClassRec;

typedef struct {
	/* resources */
	Boolean		slave_mode;
	Boolean		show_always_scrollbars;
	int		scrollbar_thickness;
	int		position_x;
	int		position_y;
	int		child_width;
	int		child_height;
	int		spacing;
	XtCallbackList	scroll_cb;
	int		vincrement;
	int		hincrement;
	/* private */
	Boolean		is_in_layout;
	Boolean		normal_ins_child;
	Boolean		have_child;
	Boolean		reparented;
	Widget		vbar;
	Widget		hbar;
	Widget		clipw;
	Widget		schild;	
} ScrollWinPart;

typedef struct _ScrollWinRec {
	CorePart		core;
	CompositePart		composite;
	BaseCompPart		baseComp;
	ScrollWinPart		scrollWin;
} ScrollWinRec;

#endif
