/***************************************************************************/
/* 		This code is part of WWW graber called pavuk		   */
/*		Copyright (c) 1997,1998,1999 Ondrejicka Stefan		   */
/*		(ondrej@idata.sk)					   */
/*		Distributed under GPL 2 or later			   */
/***************************************************************************/

#ifndef _bufio_h_
#define _bufio_h_

typedef struct {
	int	fd;
	char	*buf;
	int	buf_size;
	int	buf_start;
	int	buf_end;
	int	bufio_errno;
	int	eof;
} bufio;

#if NeedFunctionPrototypes
extern bufio	*bufio_fdopen(int);
extern bufio	*bufio_open(char *, int);
extern bufio	*bufio_copen(char *, int, int);
extern int	bufio_read(bufio *, void *, int);
extern int	bufio_nbfread(bufio *, void *, int);
extern int	bufio_readln(bufio *, void *, int);
extern void	bufio_unread(bufio *, void *, int);
extern int	bufio_write(bufio * , void *, int);
extern int	bufio_swrite(bufio *, void *, ...);
extern int	bufio_close(bufio *);
extern void	bufio_free(bufio *);
extern void	bufio_reset(bufio *);
#else
extern bufio	*bufio_fdopen();
extern bufio	*bufio_open();
extern bufio	*bufio_copen();
extern int	bufio_read();
extern int	bufio_nbfread();
extern int	bufio_readln();
extern void	bufio_unread();
extern int	bufio_write();
extern int	bufio_swrite();
extern int	bufio_close();
extern void	bufio_free();
extern void	bufio_reset();
#endif

#define bufio_getfd(s) ((s)->fd)


#endif
