/***************************************************************************/
/* 		This code is part of WWW graber called pavuk		   */
/*		Copyright (c) 1997,1998,1999 Ondrejicka Stefan		   */
/*		(ondrej@idata.sk)					   */
/*		Distributed under GPL 2 or later			   */
/***************************************************************************/

#ifndef _doc_h_
#define _doc_h_
#include <time.h>

#include "url.h"
#include "tools.h"

#define _RELOAD 1

typedef struct {
        url     	*doc_url;	/*** URL dokumentu ***/
        char		*mime;		/*** mime hlavicka dokumentu ***/
        char		*type_str;	/*** retazec typu dokumntu z MIME hlavicky ***/
        int		is_html;	/*** indikacia ci je to HTML dokumemt ***/
        int     	size;		/*** velkost dokumentu ***/
        char    	*contents;	/*** adresa ulozenia dokumentu v pamati ***/
        bool		save_online;	/*** indikacia ci ma byt dokument online zapisovany na disk alebo sa ma najskor nacitat do pamati ***/
        struct tm	*dtime;		/*** creation time of document ***/
        time_t		stime;		/*** time of document request ***/
        int		rest_pos;	/*** restart position ***/
	char 		*etag;		/*** ETag or Last-Modified for conditional partial HTTP GET method ***/
} doc;

#if NeedFunctionPrototypes
extern int download_document(doc * , int , int);
extern int store_document(doc * , int);
extern int remove_document(url *);
#else
extern int download_document();
extern int store_document();
extern int remove_document();
#endif

#endif
