/***************************************************************************/
/* 		This code is part of WWW graber called pavuk		   */
/*		Copyright (c) 1997,1998,1999 Ondrejicka Stefan		   */
/*		(ondrej@idata.sk)					   */
/*		Distributed under GPL 2 or later			   */
/***************************************************************************/

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <netdb.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <ctype.h>
#include <time.h>

#include "config.h"
#include "url.h"
#include "tools.h"
#include "ftp.h"
#include "net.h"
#include "doc.h"
#include "mode.h"
#include "http.h"
#include "dns.h"
#include "uexit.h"
#include "times.h"

/********************************************************/
/* zistenie navratoveho kodu z FTP servera 		*/
/********************************************************/
int ftp_get_response(sock , mbuf , setrc)
bufio *sock;
char **mbuf;
int setrc;
{
	char buf[1024];
	bool end = FALSE;
	int alen,tlen=0;
	char *sresp = NULL;

	while (!end)
	{
		_Xt_Serve
		if ((alen = bufio_readln(sock , buf , sizeof(buf))) > 0)
		{
#ifdef DEBUG
			if (cfg.debug) xprintf(1 , "%s" , buf);
#endif
			if (mbuf)
			{
				tlen +=alen;
				sresp = _realloc(sresp , tlen + 1);
				memcpy(sresp + tlen - alen , buf , alen + 1);
			}

			if(strlen(buf) > 3)
			{
				if (isdigit(*(buf)) && isdigit(*(buf + 1)) && 
				    isdigit(*(buf + 2)) && isspace(*(buf+3))) end = TRUE;
			}
		}
		else
		{
			if (alen)
				xperror("ftp_get_response");
			else
				xprintf(1 , gettext("ftp_get_response: ftp control connection closed before any response\n"));
			if (setrc) cfg.ftp_respc = 600;
			return 600;
		}
	}

	if (mbuf) *mbuf = sresp;

	if (setrc) cfg.ftp_respc = _atoi(buf);

	return _atoi(buf);
}

bufio *ftp_open_data(sock)
bufio *sock;
{
	bufio *dsock = NULL;
	int port_no;
	char buf[256];
	char *mbuf;
	int reply,h0,h1,h2,h3,p0,p1,n;

	if (!cfg.ftp_activec || (cfg.ftp_proxy && cfg.ftp_dirtyp))
	{
		sprintf(buf , "PASV\r\n");
#ifdef DEBUG
		if (cfg.debug)
			xprintf(1 , buf);
#endif
		bufio_write(sock , buf , strlen(buf));

		mbuf = NULL;

		if ((reply = ftp_get_response(sock , &mbuf , TRUE)) >= 400)
		{
			cfg.ftp_control = NULL;
			shutdown(bufio_getfd(sock),2);
			bufio_close(sock);
			cfg.ftp_fatal_err = (reply == 600);
			cfg.errcode = ERR_FTP_DATACON;
			_free(mbuf);
			return NULL;
		}

		if (!mbuf)
		{
			cfg.ftp_control = NULL;
			shutdown(bufio_getfd(sock),2);
			bufio_close(sock);
			cfg.errcode = ERR_FTP_DATACON;
			return NULL;
		}

		n = sscanf(mbuf, "%d %*[^(] (%d,%d,%d,%d,%d,%d)", &reply, &h0, &h1, &h2, &
			h3, &p0, &p1);

		_free(mbuf);

		if (n != 7 || reply != 227)
 		{
			cfg.errcode = ERR_FTP_DATACON;
			return NULL;
 		}

		port_no = (p0 << 8) + p1;

		sprintf(buf , "%d.%d.%d.%d" , h0 , h1 , h2 , h3);

		if (cfg.ftp_proxy && cfg.ftp_dirtyp)
		{
			if (!(dsock = bufio_fdopen(net_connect(cfg.ftp_proxy , cfg.ftp_proxy_port))))
			{
				cfg.errcode = ERR_PROXY_CONNECT;
				return NULL;		
 			}
			if (http_dumy_proxy_connect(dsock , buf , port_no))
			{
				cfg.errcode = ERR_PROXY_CONNECT;	
				shutdown(bufio_getfd(dsock) , 2);
				bufio_close(dsock);
				return NULL;
			}
		}
		else
		{
			if (!(dsock = bufio_fdopen(net_connect(buf , port_no))))
			{
				cfg.errcode = ERR_FTP_DATACON;
				return NULL;		
	 		}
		}
	}
	else
	{
		struct sockaddr_in addr;
		char *p;
		struct in_addr pom;

		if (!cfg.ftp_datasock)
		{
			if (!(cfg.ftp_datasock = bufio_fdopen(net_bindport(0))))
				return NULL;
		}

		if (!cfg.local_host)
		{
			if (gethostname(buf , sizeof(buf))) return NULL;
			cfg.local_host = new_string(buf);
		}

		if (dns_gethostbyname(cfg.local_host , &n , &pom)) return NULL;

		n = sizeof(addr);
		if (getsockname(bufio_getfd(cfg.ftp_datasock) , (struct sockaddr*) &addr, &n))
		{
			xperror("getsockname");
			bufio_close(sock);
			return NULL;
		}

		mbuf = inet_ntoa(pom);

		for(p = mbuf ; (p = strchr(p , '.')) ; *p = ',');
		
		sprintf(buf , "PORT %s,%d,%d\r\n" , mbuf ,
			ntohs(addr.sin_port) / 256 , ntohs(addr.sin_port) % 256);


#ifdef DEBUG
		if (cfg.debug)
			xprintf(1 , buf);
#endif
		bufio_write(sock , buf , strlen(buf));

		if ((reply = ftp_get_response(sock , NULL , TRUE)) >= 400)
		{
			cfg.ftp_control = NULL;
			shutdown(bufio_getfd(sock),2);
			bufio_close(sock);
			cfg.ftp_fatal_err = (reply == 600);
			cfg.errcode = ERR_FTP_DATACON;
			return NULL;
		}

		dsock = NULL;
		dsock = cfg.ftp_datasock;
	}

 	_Xt_Serve
 
	return dsock;
}

/****************************************************************/
/* otvorenie spojenia na FTP server, prihlasenie + zahajenie	*/
/* prenosu suboru / adresara					*/
/****************************************************************/
bufio *ftp_connect(host, port , user , password , filename , is_dir , pos , modtime)
char *host;
int port;
char *user;
char *password;
char *filename;
bool *is_dir;
int pos;
struct tm *modtime;
{
	bufio *sock = NULL , *dsock = NULL;
	char buf[2048];
	int reply;
	char *mbuf;

	cfg.errcode = ERR_NOERROR;
	cfg.ftp_fatal_err = FALSE;
	cfg.ftp_respc = 0;
	*is_dir = FALSE;

	sock = cfg.ftp_control;

	if (!cfg.ftp_control)
	{
		if (cfg.ftp_proxy && cfg.ftp_dirtyp)
		{
			if (!(sock = bufio_fdopen(net_connect(cfg.ftp_proxy , cfg.ftp_proxy_port))))
			{
				cfg.errcode = ERR_PROXY_CONNECT;
				return NULL;		
 			}

			if (http_dumy_proxy_connect(sock , host , port))
			{
				cfg.errcode = ERR_PROXY_CONNECT;	
				return NULL;
			}
		}
		else
		{
			if (!(sock = bufio_fdopen(net_connect(host,port))))
			{
				if (h_errno != 0)
					xherror(host);
				else
					xperror("net_connect");
				cfg.errcode = ERR_FTP_CONNECT;
				cfg.ftp_fatal_err = TRUE;
				return NULL;
			}
		}
		cfg.ftp_control = sock;

		_Xt_Serve
		if (ftp_get_response(sock , NULL , TRUE) >= 400)
		{
			cfg.ftp_control = 0;
			shutdown(bufio_getfd(sock),2);
			bufio_close(sock);
			cfg.ftp_fatal_err = TRUE;
			cfg.errcode = ERR_FTP_CONNECT;
			return NULL;
		}

		sprintf(buf , "USER %s\r\n" , user);
#ifdef DEBUG
		if (cfg.debug)
			xprintf(1 , buf);
#endif
		bufio_write(sock , buf , strlen(buf));
		_Xt_Serve
		if (ftp_get_response(sock , NULL , TRUE) >= 400)
		{
			cfg.ftp_control = NULL;
			shutdown(bufio_getfd(sock),2);
			bufio_close(sock);
			cfg.ftp_fatal_err = TRUE;
			cfg.errcode = ERR_FTP_BUSER;
			return NULL;
		}
		_Xt_Serve
		sprintf(buf , "PASS %s\r\n" , password);
#ifdef DEBUG
		if (cfg.debug)
			xprintf(1 , buf);
#endif
		bufio_write(sock , buf , strlen(buf));

		if (ftp_get_response(sock , NULL , TRUE) >= 400)
		{
			cfg.ftp_control = NULL;
			shutdown(bufio_getfd(sock),2);
			bufio_close(sock);
			cfg.ftp_fatal_err = TRUE;
			cfg.errcode = ERR_FTP_BPASS;
			return NULL;
		}
		_Xt_Serve
		sprintf(buf , "TYPE I\r\n");
#ifdef DEBUG
		if (cfg.debug)
			xprintf(1 , buf);
#endif
		bufio_write(sock , buf , strlen(buf));

		if ((reply = ftp_get_response(sock , NULL , TRUE)) >= 400)
		{
			cfg.ftp_control = 0;
			shutdown(bufio_getfd(sock),2);
			bufio_close(sock);
			cfg.ftp_fatal_err = (reply == 600);
			cfg.errcode = ERR_FTP_UNKNOWN;
			return NULL;
		}
	}
#ifdef DEBUG
	else
	{
		if (cfg.debug)
			xprintf(1 , gettext("FTP control connection next use\n"));
	}
#endif

	_Xt_Serve

	if (*(filename + strlen(filename) -1) != '/')
	{ 
		sprintf(buf , "SIZE %s\r\n",filename);
#ifdef DEBUG
		if (cfg.debug)
			xprintf(1 , buf);
#endif
		bufio_write(sock , buf , strlen(buf));
	 	_Xt_Serve

		mbuf = NULL;
		if ((reply = ftp_get_response(sock , &mbuf , TRUE)) == 213)
		{
			sscanf(mbuf , "%d %d" , &reply , &cfg.totsz);
		}
		else
		{
			if (reply == 600)
			{
				cfg.errcode = ERR_READ;
				cfg.ftp_fatal_err = TRUE;
				_free(mbuf);
				return NULL;
			}
		}

		_free(mbuf);

		if (reply != 550) /*** file doesn't exists or not plain file  == 550 ***/
		{
		    if (cfg.check_limits && cfg.totsz && cfg.condition.max_size && 
			cfg.totsz > cfg.condition.max_size)
		    {
			cfg.errcode = ERR_BIGGER;
			return NULL;
		    }
		    if (cfg.check_limits && cfg.totsz && cfg.condition.min_size && 
			cfg.totsz > cfg.condition.min_size)
		    {
			cfg.errcode = ERR_BIGGER;
			return NULL;
		    }


		    sprintf(buf , "MDTM %s\r\n" , filename);
#ifdef DEBUG
		    if (cfg.debug)
			xprintf(1 , buf);
#endif
		    bufio_write(sock , buf , strlen(buf));
		    _Xt_Serve

		    mbuf = NULL;
		    if ((reply = ftp_get_response(sock , &mbuf , TRUE)) == 213)
		    {
			sscanf(mbuf , "%d %s" , &reply , buf);
			if (strlen(buf) == 14)
			{
				_free(cfg.act_doc->dtime);
				cfg.act_doc->dtime = time_ftp_scn(buf);
			}
		    }
		    else if (reply == 500 || reply == 502)
		    {
			cfg.errcode = ERR_FTP_NOMDTM;
		    }
		    else
		    {
			if (reply == 600)
			{
				cfg.ftp_fatal_err = TRUE;
				cfg.errcode = ERR_READ;
				_free(mbuf);
				return NULL;
			}
		    }
		    _free(mbuf);


                    if (cfg.origsize && cfg.totsz && (cfg.origsize != cfg.totsz))
                    {
                    	xprintf(1 , gettext("Size differs regeting whole\n"));
                    	pos = cfg.act_doc->rest_pos = 0;
                    }
		    else if (modtime && cfg.act_doc->dtime)
		    {
			if ((difftime(mktime(cfg.act_doc->dtime) , mktime(modtime)) > 0))
			{
				if (pos)
				{
					pos = 0;
					cfg.act_doc->rest_pos = 0;
					xprintf(1 , gettext("Modified from last download - regeting whole\n"));
				}
			}
			else if (cfg.mode == MODE_SYNC && !pos)
			{
				cfg.errcode = ERR_FTP_ACTUAL;
				return NULL;
			}
			else
			{
				if (cfg.check_limits && cfg.condition.btime &&
				    (difftime(mktime(cfg.act_doc->dtime) , 
				   	     cfg.condition.btime) < 0))
				{
					cfg.errcode = ERR_OUTTIME;
					return NULL;
				}
				if (cfg.check_limits && cfg.condition.etime &&
				    (difftime(mktime(cfg.act_doc->dtime) , 
				   	     cfg.condition.etime) > 0))
				{
					cfg.errcode = ERR_OUTTIME;
					return NULL;
				}
			}
		    }

		    if (cfg.check_limits && cfg.condition.uexit)
		    {
			if (!uexit_condition(cfg.act_doc->doc_url , 
				&cfg.totsz ,
				cfg.act_doc->dtime))
			{
				cfg.errcode = ERR_SCRIPT_DISABLED;
				return NULL;
			}
		    }

		    if (!(dsock = ftp_open_data(sock)))
		    {
			cfg.errcode = ERR_FTP_DATACON;
			return NULL;
		    }

		    if (pos)
		    {
			sprintf(buf , "REST %d\r\n" , pos);
#ifdef DEBUG
			if (cfg.debug)
				xprintf(1 , buf);
#endif
			bufio_write(sock , buf , strlen(buf));
			if ((reply = ftp_get_response(sock , NULL , TRUE)) >= 400)
			{
				if (reply == 600)
				{
					cfg.ftp_fatal_err = TRUE;
					shutdown(bufio_getfd(dsock) , 2);
					bufio_close(dsock);
					cfg.ftp_datasock = NULL;
					cfg.errcode = ERR_READ;
					return NULL;
				}
				cfg.errcode = ERR_FTP_NOREGET;
			}
		    }
		    _Xt_Serve

		    sprintf(buf , "RETR %s\r\n",filename);
#ifdef DEBUG
		    if (cfg.debug)
			xprintf(1 , buf);
#endif
		    bufio_write(sock , buf , strlen(buf));
		    if (!((reply = ftp_get_response(sock , NULL , TRUE)) >= 400))
		    {			
			if (cfg.ftp_activec && !(cfg.ftp_proxy && cfg.ftp_dirtyp))
			{
				dsock = bufio_fdopen(net_accept(bufio_getfd(cfg.ftp_datasock)));
				shutdown(bufio_getfd(cfg.ftp_datasock) , 2);
				bufio_close(cfg.ftp_datasock);
				cfg.ftp_datasock = NULL;
			}	
			return dsock;
		    }

		    if (reply == 600)
		    {
		    	cfg.ftp_fatal_err = TRUE;
			shutdown(bufio_getfd(dsock) , 2);
			bufio_close(dsock);
			cfg.ftp_datasock = NULL;
			cfg.errcode = ERR_READ;
			return NULL;
		    }
		    cfg.errcode = ERR_FTP_GET;
		}
		else
		{
			cfg.errcode = ERR_FTP_GET;
		}
	}
	else *is_dir = TRUE;


	if ((cfg.check_limits && cfg.condition.ftpdir) || !cfg.check_limits)
	{
		_Xt_Serve
		sprintf(buf , "CWD %s\r\n" , filename);
#ifdef DEBUG
		if (cfg.debug)
			xprintf(1 , buf);
#endif
		bufio_write(sock , buf , strlen(buf));

		if ((reply = ftp_get_response(sock , NULL , TRUE)) >= 400)
		{
			if (dsock)
			{
				shutdown(bufio_getfd(dsock) , 2);
				bufio_close(dsock);
				cfg.ftp_datasock = NULL;
			}
			cfg.ftp_fatal_err = (reply == 600);
			cfg.errcode = *is_dir ?
				ERR_FTP_NODIR : ERR_FTP_GET;
			return NULL;
		}
		
		_Xt_Serve

		if (!dsock)
		{
			if (!(dsock = ftp_open_data(sock)))
			{
				return NULL;
			}
		}

		if (cfg.ftp_list)
			sprintf(buf , "LIST\r\n");
		else
			sprintf(buf , "NLST\r\n");
#ifdef DEBUG
		if (cfg.debug)
			xprintf(1 , buf);
#endif
		bufio_write(sock , buf , strlen(buf));
		if (!((reply = ftp_get_response(sock , NULL , TRUE)) >= 400))
		{
			cfg.errcode = ERR_NOERROR;
			*is_dir = TRUE;
			if (cfg.ftp_activec && !(cfg.ftp_proxy && cfg.ftp_dirtyp))
			{
				dsock = bufio_fdopen(net_accept(bufio_getfd(cfg.ftp_datasock)));
				shutdown(bufio_getfd(cfg.ftp_datasock) , 2);
				bufio_close(cfg.ftp_datasock);
				cfg.ftp_datasock = NULL;
			}	
			return dsock;
		}
		cfg.ftp_fatal_err = (reply == 600);
		cfg.errcode = ERR_FTP_BDIR;

	} else if (!cfg.condition.ftpdir && reply == 550 && *is_dir)
	{
		cfg.errcode = ERR_FTP_DIRNO;
	}

	if (dsock)
	{
		shutdown(bufio_getfd(dsock) , 2);
		bufio_close(dsock);
		cfg.ftp_datasock = NULL;
	}

	return NULL;
}

/********************************************************/
/* pre dane  FTP URL vracia deskriptor datoveho spojenia*/
/********************************************************/
bufio *ftp_get_data_socket(urlr , pos , modtime)
url *urlr;
int pos;
struct tm *modtime;
{
	char *user;
	char *password;
	char pom[100];

	user = url_get_user(urlr, NULL);
	password = url_get_pass(urlr, NULL);

	if (!user)
		user = "anonymous";

	if (!password)
		password = cfg.send_from ? cfg.from : "pavuk@domain.xx"; 

	if (cfg.ftp_proxy && !cfg.ftp_dirtyp)
	{
		sprintf(pom , "%s@%s %d" , user , urlr->p.ftp.host , urlr->p.ftp.port);
		user = pom;
	}

	return ftp_connect(cfg.ftp_proxy && !cfg.ftp_dirtyp ? 
			cfg.ftp_proxy : urlr->p.ftp.host , 
		cfg.ftp_proxy && !cfg.ftp_dirtyp ? 
			cfg.ftp_proxy_port : urlr->p.ftp.port , 
		user , password , urlr->p.ftp.path , &urlr->p.ftp.dir ,
		pos , modtime);
}

/********************************************************/
/* z FTP adresara urobi HTML dokument			*/
/********************************************************/
void ftp_dir_to_html(docp)
doc *docp;
{
	char *p,*res = NULL;
	char pom[PATH_MAX];
	int tsize;

	sprintf(pom , gettext("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Final//EN\">\n\
<HTML>\n<TITLE>\nDirectory of ftp://%s:%d%s\n</TITLE>\n<BODY>\n<H1 ALIGN=CENTER><B>\
List of FTP directory ftp://%s:%d/%s </H1><BR><UL>") ,
docp->doc_url->p.ftp.host , docp->doc_url->p.ftp.port , docp->doc_url->p.ftp.path ,
docp->doc_url->p.ftp.host , docp->doc_url->p.ftp.port , docp->doc_url->p.ftp.path);

	res = new_string(pom);
	tsize = strlen(pom);

	p = strtok(docp->contents , "\r\n");

	while (p)
	{
		
		if (docp->doc_url->p.ftp.user && docp->doc_url->p.ftp.password)
		{
			sprintf(pom , 
			"<LI><A HREF=\"ftp://%s:%s@%s:%d%s/%s\">&quot;%s&quot;</A>\n" ,
			docp->doc_url->p.ftp.user , docp->doc_url->p.ftp.password ,
			docp->doc_url->p.ftp.host , docp->doc_url->p.ftp.port ,
			docp->doc_url->p.ftp.path , p , p);
		}
		else if (docp->doc_url->p.ftp.user)
		{
			sprintf(pom , 
			"<LI><A HREF=\"ftp://%s@%s:%d%s/%s\">&quot;%s&quot;</A>\n" ,
			docp->doc_url->p.ftp.user , 
			docp->doc_url->p.ftp.host , docp->doc_url->p.ftp.port ,
			docp->doc_url->p.ftp.path , p , p);
		}
		else
			sprintf(pom , 
			"<LI><A HREF=\"ftp://%s:%d%s/%s\">&quot;%s&quot;</A>\n" ,
			docp->doc_url->p.ftp.host , docp->doc_url->p.ftp.port ,
			docp->doc_url->p.ftp.path , p , p);

		tsize += strlen(pom);
		res = _realloc(res , tsize + 1);

		strcat(res , pom);
		p = strtok(NULL , "\r\n");
	}
	
	tsize += 22;
	res = _realloc(res , tsize + 1);

	strcat(res , "</UL>\n</BODY>\n</HTML>\n");

	free(docp->contents);

	docp->contents = res;
	docp->size = tsize;
}

static int ftp_list_perm_parse(str)
char *str;
{
	int perm = 0;
	int i;
	char *s;

	if (strlen(str) != 10)
		return -1;

	for (s = str+1 , i = 0; i < 3; i++ , s += 3)
	{
		perm <<= 3;
		if (s[0] == 'r') perm += 4;
		if (s[1] == 'w') perm += 2;
		if (s[2] == 'x') perm += 1;
	}
	return perm;
}

static int ftp_list_perm_type(str)
char *str;
{
	switch (str[0])
	{
		case 'd': return FTP_TYPE_D;
		case 'l': return FTP_TYPE_L;
		default: return FTP_TYPE_F;
	}
}

static void ftp_list_get_slink(str , nm ,ln)
char *str;
char **nm;
char **ln;
{
	char *p;

	*ln = NULL;
	*nm = str;

	if ((p = strstr(str , " -> ")))
	{
		*p = '\0';
		*ln = p + 4;
	}
}

static ftp_url_extension  *ftp_parse_list_line(str, fname)
char *str;
char **fname;
{
	static ftp_url_extension ret;
	char pom[PATH_MAX];
	char name[PATH_MAX];
	char attrib[PATH_MAX];
	unsigned int pi;
	char *nm,*sln;

	*fname = NULL;

	if (sscanf(str , "%s %u %s %s %u %s %u %s %[^\n\r]" , attrib , &pi ,
		pom , pom , &(ret.size) , pom , &pi , pom , name)
		!= 9)
	{
		return NULL;
	}

	ret.type = ftp_list_perm_type(attrib);
	ret.perm = ftp_list_perm_parse(attrib);
	if (ret.perm == -1)
		return NULL;
	ftp_list_get_slink(name , &nm , &sln);

	ret.slink = new_string(sln);
	*fname = new_string(nm);
	
	return &ret;
}

/********************************************************/
/* z vypisu FTP adresara urobi HTML dokument		*/
/********************************************************/
void ftp_dir_list_to_html(docp)
doc *docp;
{
	char *p,*res = NULL;
	char pom[PATH_MAX];
	char urlstr[PATH_MAX];
	int tsize;
	ftp_url_extension  *ext;
	char *name;

	sprintf(pom , gettext("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Final//EN\">\n\
<HTML>\n<TITLE>\nDirectory of ftp://%s:%d%s\n</TITLE>\n<BODY>\n<H1 ALIGN=CENTER><B>\
List of FTP directory ftp://%s:%d/%s </H1><BR><UL>") ,
docp->doc_url->p.ftp.host , docp->doc_url->p.ftp.port , docp->doc_url->p.ftp.path ,
docp->doc_url->p.ftp.host , docp->doc_url->p.ftp.port , docp->doc_url->p.ftp.path);

	res = new_string(pom);
	tsize = strlen(pom);

	p = strtok(docp->contents , "\r\n");

	/*** skip first total line ***/
	p = strtok(NULL , "\r\n");

	while(p)
	{
		ext = ftp_parse_list_line(p , &name);

		if (!ext)
		{
			xprintf(1 , gettext("ERROR: unable to parse FTP list line :\n\t%s\n") , p);
			p = strtok(NULL , "\r\n");
			continue;
		}

		if (!strcmp(name , ".") || !strcmp(name , ".."))
		{
			p = strtok(NULL , "\r\n");
			continue;
		} 

		if (docp->doc_url->p.ftp.user && docp->doc_url->p.ftp.password)
		{
			sprintf(pom , "ftp://%s:%s@%s:%d%s/%s" ,
			docp->doc_url->p.ftp.user , docp->doc_url->p.ftp.password ,
			docp->doc_url->p.ftp.host , docp->doc_url->p.ftp.port ,
			docp->doc_url->p.ftp.path , name);
		}
		else if (docp->doc_url->p.ftp.user)
		{
			sprintf(pom , "ftp://%s@%s:%d%s/%s" ,
			docp->doc_url->p.ftp.user , 
			docp->doc_url->p.ftp.host , docp->doc_url->p.ftp.port ,
			docp->doc_url->p.ftp.path , name);
		}
		else
			sprintf(urlstr , "ftp://%s:%d%s/%s" ,
			docp->doc_url->p.ftp.host , docp->doc_url->p.ftp.port ,
			docp->doc_url->p.ftp.path , name);

		sprintf(pom , "<LI><A PAVUKEXT=\"FTPINF %u %u %u %s\" HREF=\"%s\">&quot;%s&quot;</A> (%ub)\n" ,
			ext->type , ext->perm , ext->size , 
			(ext->slink ? ext->slink : "") ,
			urlstr , name , ext->size);

		_free(name);
		_free(ext->slink);

		tsize += strlen(pom);
		res = _realloc(res , tsize + 1);
		strcat(res , pom);

		p = strtok(NULL , "\r\n");
	}

	tsize += 22;
	res = _realloc(res , tsize + 1);

	strcat(res , "</UL>\n</BODY>\n</HTML>\n");

	free(docp->contents);

	docp->contents = res;
	docp->size = tsize;
}

ftp_url_extension *ftp_parse_ftpinf_ext(str)
char *str;
{
	ftp_url_extension *rv;
	char pom[PATH_MAX];
	unsigned int t,p,s;
	int num;

	if (strncmp(str , "FTPINF" , 6))
		return NULL;

	num = sscanf(str , "FTPINF %u %u %u %[^\n\r]" , &t , &p , &s , pom);
		
	if (num < 3) return NULL;

	rv = _malloc(sizeof(ftp_url_extension));

	rv->perm = p;
	rv->size = s;
	rv->type = t;
	rv->slink = (num == 4) ? new_string(pom) : NULL;

	return rv;
}

int ftp_make_symlink(urlp)
url *urlp;
{
	char pom[PATH_MAX];
	char *frompath,*topath;
	char *p;
	ftp_url_extension *ext = (ftp_url_extension *)urlp->extension; 
	int rv;

	frompath = url_to_filename(urlp);

	if (!cfg.preserve_links)
	{
		if (ext->slink[0] == '/')
		{
			p = urlp->p.ftp.path;
			urlp->p.ftp.path = ext->slink;
			topath  = url_to_filename(urlp);
			urlp->p.ftp.path = p;
		}
		else
		{
			strcpy(pom , urlp->p.ftp.path);
			p = strrchr(pom , '/');
			if (p) *(p+1) = '\0';
			strcat(pom , ext->slink);

			p = urlp->p.ftp.path;
			urlp->p.ftp.path = pom;
			topath  = url_to_filename(urlp);
			urlp->p.ftp.path = p;
		}
		p = topath;
		topath = get_relative_path(frompath , p);
		_free(p);
	}
	else topath = NULL;

	xprintf(1 , gettext("Making symlink \"%s\" to \"%s\"\n"),
		frompath , topath ? topath : ext->slink);
	
	makealldirs(frompath);

	if (!access(frompath , F_OK))
	{
		if(unlink(frompath))
			xperror(frompath);
	}

	rv = symlink(topath ? topath : ext->slink , frompath);

	if (rv == -1)
		xperror("topath");

	_free(frompath);
	_free(topath);

	return rv;
}

