/***************************************************************************/
/* 		This code is part of WWW graber called pavuk		   */
/*		Copyright (c) 1997,1998,1999 Ondrejicka Stefan		   */
/*		(ondrej@idata.sk)					   */
/*		Distributed under GPL 2 or later			   */
/***************************************************************************/

#ifndef __ftp_h__
#define __ftp_h__

#include <time.h>
#include "url.h"
#include "doc.h"
#include "bufio.h"

#define DEFAULT_FTP_PORT 21
#define DEFAULT_FTP_PROXY_PORT	22

#define FTP_TYPE_F	0
#define FTP_TYPE_D	1
#define FTP_TYPE_L	2

typedef struct _ftp_url_extension {
	char		type;	/*** type of file ***/
	short int	perm;	/*** permisions ***/
	unsigned int	size;	/*** size of file ***/
	char		*slink;	/*** where point symlink ***/
} ftp_url_extension;

#if NeedFunctionPrototypes
extern bufio *ftp_get_data_socket(url * , int , struct tm *);
extern void ftp_dir_to_html(doc *);
extern void ftp_dir_list_to_html(doc *);
extern int ftp_get_response(bufio * , char ** , int);
extern ftp_url_extension *ftp_parse_ftpinf_ext(char *);
extern int ftp_make_symlink(url *);
#else
extern int ftp_get_data_socket();
extern void ftp_dir_to_html();
extern void ftp_dir_list_to_html();
extern int ftp_get_response();
extern ftp_url_extension *ftp_parse_ftpinf_ext();
extern int ftp_make_symlink();
#endif

#endif
