/***************************************************************************/
/* 		This code is part of WWW graber called pavuk		   */
/*		Copyright (c) 1997,1998,1999 Ondrejicka Stefan		   */
/*		(ondrej@idata.sk)					   */
/*		Distributed under GPL 2 or later			   */
/***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <netdb.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <ctype.h>

#include "config.h"
#include "url.h"
#include "http.h"
#include "net.h"
#include "doc.h"

/********************************************************/
/* otvori spojenie na gopher server pre dane gopher URL	*/
/********************************************************/
bufio *gopher_get_data_socket(urlr)
url *urlr;
{
	bufio *sock;
	char pom[512];
	char *host;
	int port;

	if (cfg.gopher_proxy)
	{
		host = cfg.gopher_proxy;
		port = cfg.gopher_proxy_port;
	}
	else
	{
		host = urlr->p.gopher.host;
		port = urlr->p.gopher.port;
	}

	sock = bufio_fdopen(net_connect(host , port));

	if (sock)
	{
		if (cfg.gopher_proxy)
		{
			if (http_dumy_proxy_connect(sock , url_get_site(urlr) , url_get_port(urlr)))
			{
				shutdown(bufio_getfd(sock) , 2);
				bufio_close(sock);
				return NULL;
			}
		}

		sprintf(pom , "%s\r\n" , urlr->p.gopher.selector);
		bufio_write(sock , pom , strlen(pom));
#ifdef DEBUG
		if (cfg.debug)
		{
			xprintf(1 , gettext("********************* Gopher request **************\n"));
			xprintf(1 , "%s" , pom);
			xprintf(1 , "***************************************************\n");
		}
#endif
	}
	else
	{
		cfg.errcode = ERR_GOPHER_CONNECT;
		if (h_errno)
			xherror(host);
		else
			xperror("net_connect");
	}


	return sock;
}

/********************************************************/
/* z gopher adresara urobi HTML dokument		*/
/********************************************************/
void gopher_dir_to_html(docp)
doc *docp;
{
	char *p,*res = NULL;
	char pom[1024];
	int tsize,s;
	char tp;
	char *title;
	char *host;
	char *sel;
	int port;

	if (docp->doc_url->p.gopher.type != '1') return;

	sprintf(pom , gettext("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Final//EN\">\n\
<HTML>\n<TITLE>\nDirectory of gopher://%s:%d/%c%s\n</TITLE>\n<BODY>\n<H1 ALIGN=CENTER><B>\
Directory of gopher://%s:%d/%c%s </H1><BR><BR><UL>") ,
docp->doc_url->p.gopher.host , docp->doc_url->p.gopher.port ,
docp->doc_url->p.gopher.type , docp->doc_url->p.gopher.selector ,
docp->doc_url->p.gopher.host , docp->doc_url->p.gopher.port ,
docp->doc_url->p.gopher.type , docp->doc_url->p.gopher.selector);

	res = new_string(pom);
	tsize = strlen(pom);

	p = strtok(docp->contents , "\r\n");

	while (p)
	{
		if (*p == '.') break;

		s = strlen(p);

		title = strtokc(p, '\t');
		tp = *title;
		title++;

		sel = strtokc(NULL , '\t');
		host = strtokc(NULL , '\t');
		port = _atoi(strtokc(NULL , '\t'));

		sprintf(pom , 
			"<LI><A HREF=\"gopher://%s:%d/%c%s\">&quot;%s&quot;</A></LI>\n" ,
			host , port , tp , sel , title);

		tsize += strlen(pom);
		res = _realloc(res , tsize + 1);

		strcat(res , pom);
		p = strtok(NULL , "\r\n");
	}
	
	tsize += 22;
	res = _realloc(res , tsize + 1);

	strcat(res , "</UL>\n</BODY>\n</HTML>\n");

	free(docp->contents);

	docp->contents = res;
	docp->size = tsize;
}
