/***************************************************************************/
/* 		This code is part of WWW graber called pavuk		   */
/*		Copyright (c) 1997,1998,1999 Ondrejicka Stefan		   */
/*		(ondrej@idata.sk)					   */
/*		Distributed under GPL 2 or later			   */
/***************************************************************************/

#include <stdio.h>
#include <unistd.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <utime.h>

#ifdef HAVE_SYS_MODE_H
#include <sys/mode.h>
#endif

#include "config.h"
#include "tools.h"
#include "url.h"
#include "doc.h"
#include "condition.h"
#include "html.h"
#include "css.h"
#include "ftp.h"


#define NARAZNIK	4096
#define MEXPAND(sv)		if ((sz - (sv + r)) < NARAZNIK)\
			{\
				 result = _realloc(result , sz + sv + NARAZNIK);\
				 sz += NARAZNIK + sv;\
			}

#define SEXPAND(sv)		if ((ssz - (sr + sv)) < NARAZNIK)\
			{\
				 stack = _realloc(stack , ssz + sv + NARAZNIK);\
				 ssz += NARAZNIK + sv;\
			}

/************************************************************/
/* tabulka znamych znaciek a atributov ktore sa spracovavaju*/
/************************************************************/
html_tag linky[93] =
{
	{"HEAD" ,
		{{"PROFILE" , LINK_INLINE | LINK_DOWNLD} ,
		{NULL , 0}}},
	{"BODY" , 
		{{"BACKGROUND" , LINK_INLINE |  LINK_DOWNLD} , 
		 {"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"TABLE" , 
		{{"BACKGROUND" , LINK_INLINE |  LINK_DOWNLD} , 
		 {"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"TH" , 
		{{"BACKGROUND" , LINK_INLINE |  LINK_DOWNLD} , 
		 {"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"TD" , 
		{{"BACKGROUND" , LINK_INLINE |  LINK_DOWNLD} , 
		 {"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"IMG" , 
		{{"SRC" , LINK_INLINE | LINK_DOWNLD},
		 {"LONGDESC" , LINK_DOWNLD},
		 {"USEMAP" , LINK_DOWNLD | LINK_INLINE},
		 {"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"INPUT" ,
		{{"SRC" , LINK_INLINE | LINK_DOWNLD},
		 {"USEMAP" , LINK_INLINE | LINK_DOWNLD},
		 {"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"FRAME" , 
		{{"SRC" , LINK_INLINE | LINK_DOWNLD},
		 {"LONGDESC" , LINK_DOWNLD},
		 {"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"IFRAME" , 
		{{"SRC" , LINK_DOWNLD},
		 {"LONGDESC" , LINK_DOWNLD},
		 {"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"APPLET" , 
		{{"CODEBASE" , 0},
		 {"STYLE" , LINK_STYLE},
		 {NULL , 0}}},
	{"SCRIPT" , 
		{{"SRC" , 0},
		 {NULL , 0}}},
	{"SOUND" , 
		{{"SRC" , LINK_INLINE | LINK_DOWNLD},
		 {"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"BGSOUND" , 
		{{"SRC" , LINK_INLINE | LINK_DOWNLD},
		 {"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"EMBED" , 
		{{"SRC" , LINK_INLINE | LINK_DOWNLD},
		 {"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"AREA" , 
		{{"HREF" , LINK_DOWNLD},
		 {"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"BASE" , 
		{{"HREF" , 0},
		 {NULL , LINK_REMOVE}}},
	{"FIG" , 
		{{"SRC" , LINK_INLINE | LINK_DOWNLD},
		 {"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"OVERLAY" , 
		{{"SRC" , LINK_INLINE | LINK_DOWNLD},
		 {"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"A" , 
		{{"HREF", LINK_DOWNLD},
		 {"STYLE" , LINK_STYLE},
		 {NULL , 0}}},
	{"LINK" , 
		{{"HREF" , LINK_DOWNLD | LINK_INLINE},
		 {"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"FORM" , 
		{{"ACTION" , 0},
		 {"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"LAYER" , 
		{{"SRC" , LINK_DOWNLD} ,
		 {"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"META" , 
		{{"URL" , LINK_DOWNLD},
		 {NULL , 0}}},
	{"INS" , 
		{{"CITE" , LINK_INLINE | LINK_DOWNLD},
		 {"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"DEL" , 
		{{"CITE" , LINK_INLINE | LINK_DOWNLD},
		 {"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"Q" , 
		{{"CITE" , LINK_INLINE | LINK_DOWNLD},
		 {"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"SPAN" , 
		{{"HREF" , LINK_INLINE | LINK_DOWNLD},
		 {"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"DIV" , 
		{{"HREF" , LINK_INLINE | LINK_DOWNLD},
		 {"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"OBJECT" ,
		{{"DATA" , LINK_INLINE | LINK_DOWNLD},
		 {"USEMAP" , LINK_INLINE | LINK_DOWNLD} ,
		 {"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"LAYER" ,
		{{"SRC" , LINK_INLINE | LINK_DOWNLD},
		 {"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"ADDRESS" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"BLOCKQUTE" ,
		{{"CITE" , LINK_INLINE | LINK_DOWNLD},
		 {"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"CENTER" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"H1" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"H2" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"H3" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"H4" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"H5" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"H6" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"HR" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"ISINDEX" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"P" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"PRE" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"NOSCRIPT" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"DIR" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"DL" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"DT" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"DD" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"LI" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"MENU" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"OL" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"UL" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"CAPTION" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"COLGROUP" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"COL" ,
		{{"BACKGROUND" , LINK_INLINE |  LINK_DOWNLD} , 
		 {"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"THEAD" ,
		{{"BACKGROUND" , LINK_INLINE |  LINK_DOWNLD} , 
		 {"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"TFOOT" ,
		{{"BACKGROUND" , LINK_INLINE |  LINK_DOWNLD} , 
		 {"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"TBODY" ,
		{{"BACKGROUND" , LINK_INLINE |  LINK_DOWNLD} , 
		 {"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"FORM" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"FIELDSET" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"BUTTON" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"LEGEND" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"LABEL" ,
		{{"STYLE" , LINK_STYLE} ,
		{NULL , 0}}},
	{"SELECT" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"OPTGROUP" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"OPTION" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"TEXTAREA" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"BDO" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"BR" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"FONT" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"MAP" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"SUB" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"SUP" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"ABBR" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"ACRONYM" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"CITE" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"CODE" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"DFN" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"EM" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"KBD" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"SAMP" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"STRONG" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"VAR" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"B" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"BIG" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"I" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"S" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"SMALL" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"STRIKE" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"TT" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"U" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"FRAMESET" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
	{"NOFRAMES" ,
		{{"STYLE" , LINK_STYLE} ,
		 {NULL , 0}}},
};


/**** makro zistujuce ci znak je LWS ****/
#define IS_SEP(p) (((p) == '\n') || ((p) == ' ') || ((p) == '\t') || ((p) == '\r') || ((p) == '>'))

/**** deklaracie statickych funkcii ****/
#if NeedFunctionPrototypes
static void replace_url_in_stack(char *,char * , char * , int);
static int html_to_absolute_links(char **,doc *);
#else
static void replace_url_in_stack();
static int html_to_absolute_links();
#endif

static void _omit_chars(str , chars)
char *str;
char *chars;
{
	int src,dst;

	for (src = 0 , dst = 0; str[src]; src++)
	{
		if (strchr(chars , str[src]))
			continue;
		str[dst] = str[src];
		dst++;
	}
	str[dst] = '\0';
}

/*******************************************************/
/* zo znacky vytiahne hodnodu specifikovaneho atributu */
/*******************************************************/
char *get_url_from_tag(tag,link_attrib)
char *tag;
char *link_attrib;
{
	char *pom = new_string(tag);
	char *p;
	char *retval = NULL;

	p = strtok(pom , "= \t\r\n");	

	while(p && strncasecmp(p , link_attrib , strlen(link_attrib))) 
		p = strtok(NULL , "= \t\r\n");

	if (p)
		{
		p = strtok(NULL , "");	
		if (p)
		{
			while(IS_SEP(*p) || *p == '=') p++;
			if (*p == '\"' || *p == '\'')
			{
				p++;
				if (*(p - 1) == '\"')
					p = strtokc(p , '\"');
				else
					p = strtokc(p , '\'');
				_omit_chars(p , "\t\n\r");
			}
			else
			{
				p = strtok(p," \t\n\r\'\"");
			}
			while(IS_SEP(*p)) p++;
			retval = new_string(p);
		}
	}
	free(pom);
	return retval;	
}

/*** look if tag contains specified element ***/
static int tag_co_elem(tag , elem)
char *tag;
char *elem;
{
	char *pom = new_string(tag);
	char *p;
	int ret_val;

	p = strtok(pom , "= \t\r\n");	

	while(p && strcasecmp(p , elem))
		p = strtok(NULL , "= \t\r\n");

	ret_val = (p == NULL) ? 0 : !strcasecmp(p ,elem);
	free(pom);

	return ret_val;
}

/****************************************************************/
/* V HTML dokumente najde vsetky podporovane URL splnajuce	*/
/* obmedzujuce podmienky					*/
/****************************************************************/ 
dllist *html_get_all_links(html_doc , only_inline)
doc *html_doc;
int only_inline;
{
	char *stack;
	int ssz,sr;
	char *p,*idx;
	char *psp;
	bool imgstart = FALSE;
	bool scriptstart = FALSE;
	bool commentstart = FALSE;
	bool stylestart = (bool)((html_doc->doc_url->status & URL_STYLE) != 0);
	dllist *retval = NULL;
	dllist *prev_a = NULL;
	url *purl;
	int i = 0 , j = 0;
	char *base,*baset;

	/**** nastavenie zakladneho URL dokumentu ****/

	baset = url_to_urlstr(html_doc->doc_url);
	if ((p = strrchr(baset, '#')))
	{
		*p = '\0';
	}

	base = url_to_urlstr(html_doc->doc_url);

	if (*(base + strlen(base)) != '/')
	{
		p = strrchr(base , '/');
		if (p) *(p + 1) = '\0';
	}

	ssz = 2 * NARAZNIK;
	sr = 0;
	stack = _malloc(ssz);

	/**** prechazame cely dokument po znakoch ****/
	for(p = html_doc->contents ; (p - html_doc->contents) < html_doc->size ; p++)
	{
		if (stylestart)
		{
			if (!strncasecmp(p , "</STYLE", 7))
			{
				dllist *pv;

				stylestart = FALSE;
				stack[sr] = '\0';
				pv = css_get_all_links(html_doc , stack , base , baset);
				retval = dllist_concat(retval , pv);

				continue;
			}

			stack[sr] = *p;
			sr++;
			SEXPAND(1);
			continue;
		}

		if (commentstart)
		{
			if (!strncmp(p , "-->" , 3))
				commentstart = FALSE;
			continue;
		}

		/**** zacina znacka ****/
		if (*p == '<')
		{
			imgstart = FALSE;

			if (!strncasecmp(p , "</A>" , 4))
				prev_a = NULL;

			if (!strncasecmp(p , "<STYLE" , 6))
			{
				stylestart = TRUE;
				continue;
			}

			if (!strncmp(p , "<!--" , 4))
			{
				commentstart = TRUE;
				continue;
			}

			if (scriptstart)
			{
				if (!strncasecmp(p , "</SCRIPT" , 8))
				{
					scriptstart = FALSE;
					continue;
				}
			}
			
			p++;

			/**** zisti ci je to niektora znacka z tabulky ****/
			for (i = 0 ; i < NUM_ELEM(linky) ; i++)
			{
				if (!strncasecmp(p , linky[i].tag , strlen(linky[i].tag)) 
					&& IS_SEP(*(p + strlen(linky[i].tag))))
				{
					p += strlen(linky[i].tag) - 1;
					sr = 0;
					imgstart = TRUE;
					break;
				}
			}

			sr = 0;
			if (imgstart) continue;
			p--;
		}
		/**** je koniec znacky ****/
		if (*p == '>' && imgstart)
		{
			/* zarad image */
			imgstart = FALSE;
			stack[sr] = '\0';

			if (!strcasecmp(linky[i].tag , "SCRIPT") &&
				!tag_co_elem(stack , "SRC"))
			{
				scriptstart = TRUE;
			}

			/**** vyber URL zo znacky ****/
			/* !!! inline !!! */
			for(j = 0 ; !scriptstart && linky[i].attribs[j].attrib ; j++)
			{
				if (linky[i].attribs[j].stat & LINK_DISABLED)
					continue;

				if (linky[i].attribs[j].stat & LINK_STYLE)
				{
					dllist *pv;

					stylestart = FALSE;
					stack[sr] = '\0';

					pv = css_get_all_links(html_doc , stack , base , baset);

					retval = dllist_concat(retval , pv);

					continue;
				}

				psp = get_url_from_tag(stack,linky[i].attribs[j].attrib);

				if (psp)
				{
					/**** nove zakladne URL ****/
					if (!strcasecmp(linky[i].tag,"BASE") && 
					    !strcasecmp(linky[i].attribs[j].attrib,"HREF") && psp)
					{
						purl = parse_url(psp);
						if ((purl->type == FILET) && 
							(html_doc->doc_url->type == HTTP ||
							 html_doc->doc_url->type == HTTPS ||
							 html_doc->doc_url->type == FTP))
						{
							char pom[2048];

							if (*(purl->p.file.filename) == '/')
							{
								strcpy(pom , base);
								idx = strfindnchr(pom , '/' , 3);
								if (idx)
									strcpy(idx + 1 , 
										purl->p.file.filename );
								else
								{
									strcat(pom , "/");
									strcat(pom , 
										purl->p.file.filename );
								}
							}
							else
							{
				
								sprintf(pom , "%s%s" , base ,
									purl->p.file.filename);
							}
							free_deep_url(purl);
							free(purl);
							purl = parse_url(pom);
						}
						free(base);
						base = url_to_urlstr(purl);
						if (*(base + strlen(base)) != '/')
						{
							idx = strrchr(base , '/');
							if (idx) *idx = '\0';
						}
						free_deep_url(purl);
						free(purl);
					}
					else if ((linky[i].attribs[j].stat & LINK_DOWNLD) &&
						 (!only_inline || (only_inline && linky[i].attribs[j].stat & LINK_INLINE)))
					{
						char *pom = url_to_absolute_url(base , baset , 
							html_doc->doc_url , psp);

						if (!strcmp(linky[i].tag , "A") && 
							!strcmp(linky[i].attribs[j].attrib , "HREF"))
								prev_a = NULL;

						if (pom)
						{
							_free(psp);
							psp = pom;
						}

						purl = parse_url(psp);
						purl->parent_url = (url **)_malloc(2 * sizeof(url *));
						purl->parent_url[0] = html_doc->doc_url;
						purl->parent_url[1] = NULL;
						purl->level = html_doc->doc_url->level + 1;
						if (linky[i].attribs[j].stat & LINK_INLINE) 
							purl->status |= URL_INLINE_OBJ;
						url_path_abs(purl);


						if ((cfg.mode == MODE_SYNC) && cfg.prepurlstr && (purl->type == FILET))
						{
							url *pomurl = filename_to_url(purl->p.file.filename);
							if (pomurl)
							{
								free_deep_url(purl);
								_free(purl);
								purl = pomurl;
							}
						}

						/**** previous URL refer to server side map 
						      (not handled) ****/
						if (prev_a && !strcasecmp(linky[i].tag,"IMG") &&
						    tag_co_elem(stack , "ISMAP"))
						{
							free_deep_url((url *)prev_a->data);
							retval = dllist_remove_entry(retval , prev_a);
							prev_a = NULL;
						}

						/**** splna URL obmedzujuce podmienky ****/
						if (url_append_condition(purl,TRUE))
						{
							if (purl->type == FTP)
							{
								char *pext = get_url_from_tag(stack , "PAVUKEXT");

								if (pext)
								{
									purl->extension = ftp_parse_ftpinf_ext(pext);
									if (((ftp_url_extension *)purl->extension)->type == FTP_TYPE_D)
										purl->p.ftp.dir = TRUE;
									_free(pext);
								}
							}
							/**** pridanie do zoznamu ****/
							retval = dllist_append(retval , purl);
							if (!strcmp(linky[i].tag , "A") &&
								!strcmp(linky[i].attribs[j].attrib , "HREF"))
									prev_a = dllist_last(retval);
						}
						else
						{
							free_deep_url(purl);
							free(purl);
						}
					}
					_free(psp);
				}
			}
			imgstart = FALSE;
			continue;
		}
		/**** vkladanie znakov na zasobnik ak bol zaciatok podporovanej znacky ****/
		if (imgstart)
		{
			stack[sr] = *p;
			sr++;
			SEXPAND(1);
		}
	}
	_Xt_Serve;

	free(base);
	free(baset);
	free(stack);
	return retval;
}

/************************************************/
/* spojenie dvoch zoznamov URL do jedneho 	*/
/************************************************/

void cat_links_to_url_list(l1)
dllist *l1;
{
	dllist *p = l1;
	url *same;

	while (p)
	{
		if (url_append_condition((url *)p->data , TRUE))
		{
			if ((same = url_was_befor((url *)p->data)))
			{
				link_url_in_list(same , (url *)p->data);
				free_deep_url((url *)p->data);
				_free((url *)p->data);
			}
			else
				append_url_to_list((url *)p->data);
		}
		else
		{
			free_deep_url((url *)p->data);
			_free((url *)p->data);
		}

		p = p->next;
	}

	dllist_free_all(l1);
}


/************************************************/
/* prepisanie hodnoty atributu znacky na mieste	*/
/*************************************i**********/
static void replace_url_in_stack(tag , link_attrib , urlin , pare)
char *tag;
char *link_attrib;
char *urlin;
int pare;
{
	char *pom = new_string(tag);
	char *poms = new_string(tag);
	char *p,*urls,*urle,*p2;
	char waste[1024];
	int i = 0;

	waste[0] = '\0';

	p = strtok(pom , "= \t\r\n");

	while(p && strncasecmp(p , link_attrib , strlen(link_attrib))) 
		p = strtok(NULL , "= \t\r\n");

	if (p)
	{
		p = strtok(NULL , "");	
		urls = p;
		if (p)
		{
			while(IS_SEP(*p)  || *p == '=')
			{
				waste[i] = *p;
				waste[i+1] = '\0';
				i++;
				p++;
			}

			if ((*p == '\"'))
			{
				p = strtokc(p + 1,'\"');
				_omit_chars(p , "\t\n\r");
				p2 = strtokc(NULL , '\0');
			}
			else
			{
				p = strtok(p," \t");
				p2 = strtok(NULL , "");
			}

			urle = p + strlen(p) + 1;
			*(poms + (urls - pom)) = '\0';

			if (p2 && *p2)
			{
				if (!pare)
					sprintf(tag , "%s%s\"%s\" %s" , poms , waste , urlin , p2);
				else
					sprintf(tag , "%s%s%s\" %s" , poms , waste , urlin , p2);
			}
			else
			{
				if (!pare)
					sprintf(tag , "%s%s\"%s\"" , poms , waste , urlin);
				else
					sprintf(tag , "%s%s%s\"" , poms , waste , urlin);
					
			}
		}
	}

	free(pom);
	free(poms);
}

/****************************************************************/
/* prepisanie relativnych URL v HTML dokumente na absolutne 	*/
/****************************************************************/
static int html_to_absolute_links(content , html_doc)
char **content;
doc *html_doc;
{
	char *stack;
	int ssz,sr;
	char *p;
	bool tagstart = FALSE;
	bool scriptstart = FALSE;
	bool commentstart = FALSE;
	bool stylestart = (bool)((html_doc->doc_url->status & URL_STYLE) != 0);
	char *result;
	int sz,r;
	url *purl;
	char *psp;
	int i = 0 , j = 0;
	char *base,*idx,*baset;


	sz = html_doc->size + NARAZNIK;
	result = _malloc(sz);
	r = 0;

	ssz = 2 * NARAZNIK;
	stack = _malloc(ssz);
	sr = 0;

	baset = url_to_urlstr(html_doc->doc_url);
	if ((p = strrchr(baset, '#')))
	{
		*p = '\0';
	}

	base = url_to_urlstr(html_doc->doc_url);
	if (*(base + strlen(base)) != '/')
	{
		p = strrchr(base , '/');
		if (p) *(p + 1) = '\0';
	}

	for (p = html_doc->contents  ; (p - html_doc->contents) < html_doc->size ; p++)
	{
		if (stylestart)
		{
			if (!strncasecmp(p , "</STYLE", 7))
			{
				stylestart = FALSE;

				stack[sr] = *p;
				stack[sr+1] = '\0';

				psp = css_to_absolute_links(html_doc , stack , base , baset);

				MEXPAND(strlen(psp));
				strcpy(result + r , psp);
				r += strlen(psp);
				result[r] = '\0';

				_free(psp);
				continue;
			}

			SEXPAND(1);
			stack[sr] = *p;
			sr++;
			
			continue;
		}


		if (commentstart)
		{
			if (!strncmp(p , "-->" , 3))
				commentstart = FALSE;
			
			MEXPAND(1);
			result[r] = *p;
			r++;
			result[r] = '\0';
			continue;
		}

		if (*p == '<')
		{
			if (tagstart)
			{
				stack[sr] = '\0';

				MEXPAND(strlen(stack));
				strcpy(result + r , stack);
				r += strlen(stack);
			}

			tagstart = FALSE;

			if (!strncasecmp(p , "<STYLE" , 6))
			{
				stylestart = TRUE;
				sr = 0;
			}

			if (!strncmp(p , "<!--" , 4))
			{
				commentstart = TRUE;
			}

			if (scriptstart)
			{
				if (!strncasecmp(p , "</SCRIPT" , 8))
				{
					scriptstart = FALSE;
				}
			}

			p++;

			for (i = 0 ; i < NUM_ELEM(linky) ; i++)
			{
				if (!strncasecmp(p , linky[i].tag , strlen(linky[i].tag))
				 	&& IS_SEP(*(p + strlen(linky[i].tag))))
				{
					strcpy(result + r , "<");
					strncpy(result + r + 1 , p , strlen(linky[i].tag));

					MEXPAND(strlen(linky[i].tag));
					r += strlen(linky[i].tag) + 1;
					result[r] = '\0';
					p += strlen(linky[i].tag) - 1;
					sr = 0;
					tagstart = TRUE;

					break;
				}
			}
			if (tagstart) continue;
			p--;
		}
		if (*p == '>' && tagstart)
		{
			stack[sr] = '\0';

			if (!strcasecmp(linky[i].tag , "SCRIPT") &&
				!tag_co_elem(stack , "SRC"))
			{
				scriptstart = TRUE;
			}

			for(j = 0 ; !scriptstart && linky[i].attribs[j].attrib ; j++)
			{

				psp = get_url_from_tag(stack,linky[i].attribs[j].attrib);

				if (psp)
				{
					if (linky[i].attribs[j].stat & LINK_STYLE)
					{
						char *stylestr;

						stylestr = css_to_absolute_links(html_doc , psp , base , baset);

						SEXPAND(strlen(stylestr));
						replace_url_in_stack(stack ,
							linky[i].attribs[j].attrib ,
							stylestr , FALSE);
						_free(stylestr);
						_free(psp);
						continue;
					}

					if (!strcasecmp(linky[i].tag,"BASE"))
					{
						purl = parse_url(psp);

						if ((purl->type == FILET) && 
							(html_doc->doc_url->type == HTTP ||
							 html_doc->doc_url->type == HTTPS ||
							 html_doc->doc_url->type == FTP))
						{
							char pom[2048];
	
							if (*(purl->p.file.filename) == '/')
							{
								strcpy(pom , base);
								idx = strfindnchr(pom , '/' , 3);
								if (idx)
									strcpy(idx , 
										purl->p.file.filename );
								else
								{
									strcat(pom , "/");
									strcat(pom , 
										purl->p.file.filename );
								}
							}
							else
							{
								sprintf(pom , "%s%s" , base ,
									purl->p.file.filename);
							}

							free_deep_url(purl);
							free(purl);
							purl = parse_url(pom);
						}
						free(base);
						base = url_to_urlstr(purl);
						if (*(base + strlen(base)) != '/')
						{
							idx = strrchr(base , '/');
							if (idx) *p = '\0';
						}
						free(psp);
						free_deep_url(purl);
						free(purl);
						r -= 5;
						tagstart = FALSE;
						continue;
					} 
					else
					{
						char *pom = url_to_absolute_url(base , baset , 
							html_doc->doc_url , psp);
					
						if (pom)
						{
							free(psp);
							purl = parse_url(pom);
							_free(pom);
							url_path_abs(purl);
							psp = url_to_urlstr(purl);
							free_deep_url(purl);
							_free(purl);
						}

						SEXPAND(strlen(psp));
						replace_url_in_stack(stack ,
							linky[i].attribs[j].attrib , psp ,
							(!strcasecmp(linky[i].tag,"META") && 
							 !strcasecmp(linky[i].attribs[j].attrib,"URL")));

						_free(psp);
					}
				}
			}

			MEXPAND(strlen(stack));
			strcpy(result + r , stack);
			r += strlen(stack);
			if (result[r - 1] != '>') {result[r] = '>'; r++;}
			result[r] = '\0';
			tagstart = FALSE;
			continue;
		}
		if (tagstart)
		{
			stack[sr] = *p;
			sr++;
			SEXPAND(1);
		}else
		{
			MEXPAND(1);
			result[r] = *p;
			r++;
			result[r] = '\0';
		}
	}
	free(stack);
	free(base);
	free(baset);
	*content = result;
	return (r);
}

/************************************************/
/* prepisanie relativnych  URL dokumentu 	*/
/************************************************/
void relocate_html_doc(docu)
doc *docu;
{
	int s;
	char *p;

	if (docu->doc_url->type != HTTP && 
#ifdef USE_SSL
	    docu->doc_url->type != HTTPS && 
#endif
	    docu->doc_url->type != FTP &&
	    docu->doc_url->type != GOPHER) return;

	if ((docu->doc_url->status & URL_REDIRECT)) return;

	s = html_to_absolute_links(&p , docu);

	free(docu->contents);
	docu->contents = p;
	docu->size = s;

}


/****************************************************************/
/* prepisanie vzdialenych URL v HTML dokumente na lokalne	*/
/****************************************************************/
int html_remote_to_local_links(contentout , html_doc)
char **contentout;
doc *html_doc;
{
	char *stack;
	int ssz,sr;
	char pom[4096];
	char *p;
	int sz,r;
	bool tagstart = FALSE;
	bool commentstart = FALSE;
	bool scriptstart = FALSE;
	bool stylestart = (bool)((html_doc->doc_url->status & URL_STYLE) != 0);
	char *result;
	char *psp;
	int i=0,j=0,link_idx=0;
	char *act_name = url_to_filename(html_doc->doc_url);
	char *anchor;

	sz = NARAZNIK + html_doc->size;
	r = 0;
        result = _malloc(sz);

	ssz = 2 * NARAZNIK;
	stack = _malloc(ssz);
	sr = 0;

	for (p = html_doc->contents  ; (p - html_doc->contents) < html_doc->size ; p++)
	{
		if (stylestart)
		{
			if (!strncasecmp(p , "</STYLE", 7))
			{
				stylestart = FALSE;

				stack[sr] = *p;
				sr ++;
				stack[sr] = '\0';

				psp = css_remote_to_local_links(html_doc , stack);

				MEXPAND(strlen(psp));
				strcpy(result + r , psp);
				r += strlen(psp);
				result[r] = '\0';

				_free(psp);
				continue;
			}

			stack[sr] = *p;
			sr++;
			SEXPAND(1);

			continue;
		}

		if (commentstart)
		{
			if (!strncmp(p , "-->" , 3))
				commentstart = FALSE;
			
			MEXPAND(1);
			result[r] = *p;
			r++;
			result[r] = '\0';
			continue;
		}

		if (*p == '<')
		{
			if (tagstart)
			{
				stack[sr] = '\0';

				MEXPAND(strlen(stack));
				strcpy(result + r , stack);
				r += strlen(stack);
			}

			tagstart = FALSE;

			if (!strncasecmp(p , "<STYLE" , 6))
			{
				sr = 0;
				stylestart = TRUE;
			}

			if (!strncmp(p , "<!--" , 4))
			{
				commentstart = TRUE;
			}

			if (scriptstart)
			{
				if (!strncasecmp(p , "</SCRIPT" , 8))
				{
					scriptstart = FALSE;
				}
			}

			p++;

			for (i = 0 ; i < NUM_ELEM(linky) ; i++)
			{
				if (!strncasecmp(p , linky[i].tag , strlen(linky[i].tag))
				 	&& IS_SEP(*(p + strlen(linky[i].tag))))
				{
					strcpy(result + r , "<");
					strncpy(result + r + 1 , p , strlen(linky[i].tag));

					MEXPAND(strlen(linky[i].tag));
					r += strlen(linky[i].tag) + 1;
					result[r] = '\0';

					p += strlen(linky[i].tag) - 1;
					sr = 0;
					tagstart = TRUE;
					link_idx = i;
					break;
				}
			}
			if (tagstart) continue;

			p--;
		}
		if (*p == '>' && tagstart)
		{
			stack[sr] = '\0';

			if (!strcasecmp(linky[i].tag , "SCRIPT") &&
				!tag_co_elem(stack , "SRC"))
			{
				scriptstart = TRUE;
			}

			for(j = 0 ; !scriptstart && linky[link_idx].attribs[j].attrib ; j++)
			{
				psp = get_url_from_tag(stack,linky[link_idx].attribs[j].attrib);

				if (linky[link_idx].attribs[j].stat & LINK_STYLE)
				{

					if (psp)
					{
						char *stylestr;

						stylestr = css_remote_to_local_links(html_doc , psp);

						SEXPAND(strlen(stylestr));
						replace_url_in_stack(stack , 
							linky[link_idx].attribs[j].attrib ,
							stylestr , FALSE);
						_free(stylestr);
						_free(psp);
					}
					continue;
				}

				if (psp)
				{
					url *urlp = parse_url(psp);
					char *fn = url_to_filename(urlp);
					struct stat estat;

					anchor = url_get_anchor_name(urlp);

					if ((urlp->type != FILET) && fn && ((!access(fn , R_OK) && !stat(fn , &estat)) || !strcmp(act_name , fn)))
					{
						if ((!access(fn , R_OK) && !S_ISDIR(estat.st_mode)) || !strcmp(act_name , fn))
						{
							char *relfn = get_relative_path(act_name , fn);

							if (anchor)
								sprintf(pom,"%s#%s" , relfn , anchor);	
							else strcpy(pom,relfn);

							free(relfn);

						}
						else
	 					{
							sprintf(pom , "%s/%s" , fn , cfg.index_name);

		 					if (!stat(pom , &estat) &&
		 						!S_ISDIR(estat.st_mode))
	 						{
								char *relfn = get_relative_path(act_name , pom);

								if (anchor)
									sprintf(pom,"%s#%s" , relfn , anchor);
								else strcpy(pom,relfn);

								free(relfn);
		 					}
							else
							{
								strcpy(pom , psp);
							}
		 				}
						SEXPAND(strlen(pom));
						replace_url_in_stack(stack , 
							linky[link_idx].attribs[j].attrib , pom ,
							(!strcasecmp(linky[i].tag,"META") && 
						         !strcasecmp(linky[i].attribs[j].attrib,"URL")));
					}
					free_deep_url(urlp);
					_free(urlp);
					_free(fn);
					_free(psp);
				}
			}
			MEXPAND(strlen(stack));
			strcat(result + r ,  stack);
                        r += strlen(stack);
			if (result[r - 1] != '>') {result[r] = '>'; r++;}

			tagstart = FALSE;
			continue;
		}
		if (tagstart)
		{
			stack[sr] = *p;
			sr++;
			SEXPAND(1);
		}else
		{
			MEXPAND(1);
			result[r] = *p;
			r++;
			result[r] = '\0';
		}
	}
	_free(act_name);
	_free(stack);
	*contentout = result;
	return (r);
}

/********************************************************/
/* prepisanie specifickeho URL v HTML dokumente na ine	*/
/********************************************************/
static int html_change_url(contentout , html_doc , url_old , url_new)
char **contentout;
doc *html_doc;
url *url_old;
char *url_new;
{
	char *stack;
	int sr,ssz;
	char *oldfn,*pfn;
	char *p;
	int sz,r,i,j;
	int link_idx = 0;
	bool commentstart = FALSE;
	bool scriptstart = FALSE;
	bool tagstart = FALSE;
	bool stylestart = (bool)((html_doc->doc_url->status & URL_STYLE) != 0);
	char *result;
	char *psp;
	url *purl;
	char *anchor;

	sz = NARAZNIK + html_doc->size;
	r = 0;
        result = _malloc(sz);

	ssz = 2 * NARAZNIK;
	stack = _malloc(ssz);
	sr = 0;

	oldfn = url_to_filename(url_old);

	for (p = html_doc->contents  ; (p - html_doc->contents) < html_doc->size ; p++)
	{
		if (stylestart)
		{
			if (!strncasecmp(p , "</STYLE", 7))
			{
				stylestart = FALSE;

				stack[sr] = *p;
				sr++;
				stack[sr] = '\0';

				psp = css_change_url(html_doc , stack ,  url_old , url_new);

				MEXPAND(strlen(psp));
				strcpy(result + r , psp);
				r += strlen(psp);
				result[r] = '\0';

				_free(psp);
				continue;
			}

			stack[sr] = *p;
			sr++;
			SEXPAND(1);
			
			continue;
		}

		if (commentstart)
		{
			if (!strncmp(p , "-->" , 3))
				commentstart = FALSE;
			
			MEXPAND(1);
			result[r] = *p;
			r++;
			result[r] = '\0';
			continue;
		}

		if (*p == '<')
		{
			if (tagstart)
			{
				stack[sr] = '\0';

				MEXPAND(1);
				strcpy(result + r , stack);
				r += strlen(stack);
			}

			tagstart = FALSE;

			if (!strncasecmp(p , "<STYLE" , 6))
			{
				stylestart = TRUE;
			}

			if (!strncmp(p , "<!--" , 4))
			{
				commentstart = TRUE;
			}

			if (scriptstart)
			{
				if (!strncasecmp(p , "</SCRIPT" , 8))
				{
					scriptstart = FALSE;
				}
			}

			p++;

			for (i = 0 ; i < NUM_ELEM(linky) ; i++)
			{
				if (!strncasecmp(p , linky[i].tag , strlen(linky[i].tag))
				 	&& IS_SEP(*(p + strlen(linky[i].tag))))
				{
					strcpy(result + r , "<");
					strncpy(result + r + 1 , p , strlen(linky[i].tag));

					MEXPAND(strlen(linky[i].tag));
					r += strlen(linky[i].tag) + 1;
					result[r] = '\0';

					p += strlen(linky[i].tag) - 1;
					sr = 0;
					tagstart = TRUE;
					link_idx = i;
					break;
				}
			}
			if (tagstart) continue;

			p--;
		}

		if (*p == '>' && tagstart)
		{
			stack[sr] = '\0';

			if (!strcasecmp(linky[i].tag , "SCRIPT") &&
				!tag_co_elem(stack , "SRC"))
			{
				scriptstart = TRUE;
			}

			for(j = 0 ; !scriptstart && linky[link_idx].attribs[j].attrib ; j++)
			{
				psp = get_url_from_tag(stack,linky[link_idx].attribs[j].attrib);
				if (psp)
				{

					if (linky[link_idx].attribs[j].stat & LINK_STYLE)
					{
						char *stylestr;

						stylestr = css_change_url(html_doc , psp ,  url_old , url_new);

						SEXPAND(strlen(stylestr));
						replace_url_in_stack(stack , 
							linky[link_idx].attribs[j].attrib ,
							stylestr , FALSE);

						_free(stylestr);
						continue;
					}

					pfn = NULL;
					purl = parse_url(psp);
					anchor = url_get_anchor_name(purl);

					if (purl && (purl->type != FILET) && (pfn = url_to_filename(purl)))
					{
						if (!strcmp(pfn , oldfn))
						{
							char pom[4096];
							char *ppom;

							if (anchor)
							{
								sprintf(pom , "%s#%s" , url_new , anchor);
								ppom = pom;
							}
							else
								ppom = url_new;
								
							SEXPAND(strlen(ppom));
							replace_url_in_stack(stack , 
								linky[link_idx].attribs[j].attrib , ppom ,
								(!strcasecmp(linky[link_idx].tag,"META") && 
							         !strcasecmp(linky[link_idx].attribs[j].attrib,"URL")));
						}
					}
					free_deep_url(purl);
					free(purl);
					free(psp);
					_free(pfn);
				}
			}
                        MEXPAND(strlen(stack));
                        strcat(result + r ,  stack);
                        r += strlen(stack);
			if (result[r - 1] != '>') {result[r] = '>'; r++;}
			tagstart = FALSE;
			continue;
		}
		if (tagstart)
		{
			stack[sr] = *p;
			sr++;
		}else
		{
			MEXPAND(1);
			result[r] = *p;
			r++;
			result[r] = '\0';
		}
	}
	*contentout = result;
	free(stack);
	free(oldfn);
	return (r);
}


/****************************************************************/
/* nacitanie dokumentu z ktoreho bol URL referencovane ,	*/
/* prepisanie vzdialeneho odkazu na relativny lokalny a spatne	*/
/* ulozenie							*/
/****************************************************************/
void rewrite_one_parent_links(doc_url , parent_url , dst_name)
url *doc_url;
url *parent_url;
char *dst_name;
{
	char pom[2048];
	char *fnamep;
	char *rfn;
	char *savetmp,*p;
	int sock,len;
	doc pdoc;
	char *newcont;
        struct stat estat;
	struct utimbuf ut;
	int perm;
        url dum;
/*** need to save all global setings because invoked from download_doc ***/
	bufio *save_s_sock = cfg.s_sock;
	doc *save_act_doc = cfg.act_doc;
	char *save_lock_fn = cfg.lock_fn;
	bool save_remove_lock = cfg.remove_lock;
	int save_t_error = cfg.t_error;
	int save_totsz = cfg.totsz;
	int save_origsize = cfg.origsize;
	int save_errcode = cfg.errcode;
	bool save_report_size = cfg.report_size;

#define SET_BACK_VALS\
	cfg.s_sock = save_s_sock;\
	cfg.act_doc = save_act_doc;\
	cfg.lock_fn = save_lock_fn;\
	cfg.remove_lock = save_remove_lock;\
	cfg.t_error = save_t_error;\
	cfg.totsz = save_totsz;\
	cfg.origsize = save_origsize;\
	cfg.errcode = save_errcode;\
	cfg.report_size = save_report_size;

	if (!parent_url || !(parent_url->status & URL_DOWNLOADED)) return;

	/*** parent document was not stored ***/
        if (!cfg.store_index && url_is_dir_index(parent_url)) return;

	fnamep = url_to_filename(parent_url);
        if (stat(fnamep , &estat) == 0)
        {
                if (S_ISDIR(estat.st_mode))
                {
                        xprintf(1 , gettext("Can't work on directory\n"));
                        free(fnamep);
			return;
                }
        }
	else
	{
		xperror("stat");
		return;
	}

	perm = estat.st_mode;
	ut.actime = estat.st_atime;
	ut.modtime = estat.st_mtime;

	memset(&dum, 0, sizeof(url));
	dum.type = FILET;
	dum.p.file.filename = fnamep;
	dum.status &= ~URL_REDIRECT;
	pdoc.doc_url = &dum;
	pdoc.save_online = FALSE;
	pdoc.dtime = NULL;
	pdoc.etag = NULL;
	pdoc.mime = NULL;

	cfg.act_doc = &pdoc;
	cfg.s_sock = NULL;

	cfg.report_size = FALSE;
	if (download_document(&pdoc , TRUE , TRUE))
	{
		remove_lock();
		if (cfg.errcode) report_error(cfg.errcode , "rewrite parent");
		free(fnamep);
		SET_BACK_VALS
		return;
	}

	if (cfg.errcode) report_error(cfg.errcode , "rewrite parent");

	_free(pdoc.mime);

	if (dst_name)
	{
		if  (!access(dst_name , R_OK) && !stat(dst_name , &estat))
		{
			if (!S_ISDIR(estat.st_mode))
			{
				rfn = get_relative_path(fnamep , dst_name);

				len = html_change_url(&newcont , &pdoc , doc_url , rfn);

				free(rfn);

				free(pdoc.contents);

				pdoc.contents = newcont;
				pdoc.size = len;
			}
		}
	}

	len = html_remote_to_local_links(&newcont , &pdoc);

	strcpy(pom , fnamep);
	p = strrchr(pom , '/');
	if (p)
		sprintf(p + 1 , "_*%d" , getpid());
	else
		sprintf(pom , "%s/_*%d" ,pom , getpid());

	savetmp = new_string(pom);	
	rename(fnamep , savetmp);

	if ((sock = open(fnamep , O_BINARY | O_CREAT | O_TRUNC | O_WRONLY , S_IWUSR | S_IRUSR | S_IRGRP | S_IROTH)) < 0)
	{
		xperror(fnamep);
		rename(savetmp , fnamep);
		remove_lock();
		free(savetmp);
		free(fnamep);
		free(newcont);
		free(pdoc.contents);
		SET_BACK_VALS
		return;
	}
	if (write(sock , newcont , len) != len)
	{
		xperror(fnamep);
		close(sock);
		rename(savetmp , fnamep);
		remove_lock();
		free(savetmp);
		free(fnamep);
		free(newcont);
		free(pdoc.contents);
		SET_BACK_VALS
		return;
	}
	close(sock);
	remove_lock();
	utime(fnamep , &ut);
	chmod(fnamep , perm);
	unlink(savetmp);
	free(savetmp);
	free(fnamep);
	free(newcont);
	free(pdoc.contents);
	SET_BACK_VALS

}

void rewrite_parents_links(doc_url , dst_name)
url *doc_url;
char *dst_name;
{
	int i;
	char *fn = NULL;

	if ((doc_url->status & URL_MOVED) && !dst_name) return;
	
	for (i = 0; i < doc_url->ref_cnt ; i++)
	{
		if (!doc_url->parent_url[i]) continue;

		if (doc_url->parent_url[i]->status & URL_MOVED)
		{
			fn = dst_name ? dst_name : url_to_filename(doc_url);

			rewrite_parents_links(doc_url->parent_url[i] , fn);

			if (!dst_name && fn) _free(fn);
		}
		else
		{
			rewrite_one_parent_links(doc_url , doc_url->parent_url[i] , dst_name);
		}
	}
}
