/***************************************************************************/
/* 		This code is part of WWW graber called pavuk		   */
/*		Copyright (c) 1997,1998,1999 Ondrejicka Stefan		   */
/*		(ondrej@idata.sk)					   */
/*		Distributed under GPL 2 or later			   */
/***************************************************************************/

#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "config.h"
#include "doc.h"
#include "tools.h"


/*********************************************/
/* oddelenie MIME hlavicky od tela dokumentu */
/*********************************************/

void split_mime_doc(docp)
doc *docp;
{
	char *p1,*p2;
	char *doc_c;
	int mime_size;
	
	p1 = strstr(docp->contents , "\n\n");
	p2 = strstr(docp->contents , "\r\n\r\n");

	if (p2 && ((p2 < p1) || !p1))
	{
		doc_c = p2 + 4;
		mime_size = p2 - docp->contents;
	}
	else if (p1)
	{
		doc_c = p1 + 2;
		mime_size = p1 - docp->contents;
	}
	else
	{
		doc_c = docp->contents;
		mime_size = 0;
	}

	p1 = docp->contents;

	docp->size = docp->size - (doc_c - docp->contents);

	docp->contents = (char *) _malloc(docp->size);
	memcpy(docp->contents , doc_c , docp->size);

	docp->mime = NULL;
	if (mime_size)
	{
		docp->mime = (char *) _malloc(mime_size + 3);
		strncpy(docp->mime , p1 , mime_size + 2);
		*(docp->mime +  mime_size + 2) = '\0';
	}	
	free(p1);
}

/************************************************/
/* vrati n-tu hodnotu atributu z MIME hlavicky	*/
/************************************************/
char *get_mime_n_param_val_str(param_id , mimet, n)
char *param_id;
char *mimet;
int n;
{
	char *pom,*p;
	int i = 0;

	if (!mimet) return NULL;

	pom = new_string(mimet);

	p = strtok(pom , "\n\r");

	while (p)
	{
		if (!strncasecmp(p , param_id , strlen(param_id)))
		{
			if (i == n)
			{
				p = p + strlen(param_id);
				while (isspace(*p)) p++;
				p = new_string(p);
				free(pom);

				return p;
			}
			i++;
		}
		p = strtok(NULL , "\n\r");
	}

	free(pom);

	return NULL;
}
