/***************************************************************************/
/* 		This code is part of WWW graber called pavuk		   */
/*		Copyright (c) 1997,1998,1999 Ondrejicka Stefan		   */
/*		(ondrej@idata.sk)					   */
/*		Distributed under GPL 2 or later			   */
/***************************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <netdb.h>
#include <errno.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <limits.h>
#include <time.h>

#ifdef HAVE_SYS_MODE_H
#include <sys/mode.h>
#endif

#include "config.h"
#include "url.h"
#include "doc.h"
#include "tools.h"
#include "html.h"
#include "http.h"
#include "ftp.h"
#include "abstract.h"
#include "recurse.h"
#include "mime.h"
#include "robots.h"
#include "mode.h"
#include "times.h"

extern void make_clean_dir(url *);

#ifdef I_FACE
#define SETNEXTURL	\
			short_log(&docu , urlr);\
			if (cfg.xi_face)\
				icons_set_for_doc(&docu);\
			_free(pstr);\
			_free(docu.mime);\
			_free(docu.type_str);\
			_free(docu.dtime);\
			_free(docu.contents);\
			_free(docu.etag);\
			if (!cfg.auth_reuse_nonce)\
			{\
				if (cfg.auth_digest) http_digest_deep_free(cfg.auth_digest);\
				cfg.auth_digest = NULL;\
			}\
                        if (!cfg.auth_reuse_proxy_nonce)\
                        {\
                                if (cfg.auth_proxy_digest) http_digest_deep_free(cfg.auth_proxy_digest);\
                                cfg.auth_proxy_digest = NULL;\
                        }\
                        return;
#else
#define SETNEXTURL	\
			short_log(&docu , urlr);
			_free(pstr);\
			_free(docu.mime);\
			_free(docu.type_str);\
			_free(docu.dtime);\
			_free(docu.contents);\
			_free(docu.etag);\
			if (!cfg.auth_reuse_nonce)\
			{\
				if (cfg.auth_digest) http_digest_deep_free(cfg.auth_digest);\
				cfg.auth_digest = NULL;\
			}\
                        if (!cfg.auth_reuse_proxy_nonce)\
                        {\
                                if (cfg.auth_proxy_digest) http_digest_deep_free(cfg.auth_proxy_digest);\
                                cfg.auth_proxy_digest = NULL;\
                        }\
			return;
#endif

static void reschedule_url(urlp)
url *urlp;
{
#ifdef DEBUG
	if (cfg.debug) 
		xprintf(1 , gettext("Rescheduling locked URL as nr. %d\n") , cfg.total_cnt);
#endif
	cfg.urlstack =_realloc(cfg.urlstack , 
		(cfg.total_cnt + 2) * sizeof(url *));
	cfg.urlstack[cfg.total_cnt] =  urlp;
	cfg.urlstack[cfg.total_cnt + 1] =  NULL;
	cfg.total_cnt++;
}

void process_url(urlr , check_lim)
url *urlr;
int check_lim;
{
	doc docu;
	dllist *pom;
	int pokus = 0;
	int nreget=0 , nredir=0;
	time_t atm;
	char cpom[2048];
	int num_auth,num_proxy_auth;
	char *pstr = NULL;
	char *pp = NULL;
	int store_stat;
	struct stat estat;

	docu.etag = NULL;

	if (cfg.auth_reuse_nonce && cfg.auth_digest && (urlr->type == HTTP || urlr->type == HTTPS))
	{
		if (strcmp(cfg.auth_digest->site , url_get_site(urlr)) || cfg.auth_digest->port != url_get_port(urlr))
		{
			http_digest_deep_free(cfg.auth_digest);
			cfg.auth_digest = NULL;
		}
	}

	num_auth = cfg.auth_reuse_nonce ? 1 : 0;
	num_proxy_auth = cfg.auth_reuse_proxy_nonce ? 1 : 0;

	pokus = 0;
	nredir = 0;
	nreget = 0;

	cfg.check_limits = check_lim;

	_Xt_Serve

	if (cfg.check_limits)
		cfg.check_limits = (urlr->parent_url[0] != NULL);

	while (!cfg.stop && !cfg.rbreak)
	{
		cfg.errcode = ERR_NOERROR;
		cfg.totsz = 0;
		pstr = url_to_urlstr(urlr);
		docu.mime = NULL;
		docu.type_str = NULL;
		docu.doc_url = urlr;
		docu.dtime = NULL;
		docu.contents = NULL;

		if (pokus) xprintf(1 , gettext("retry nr. %d\n"),pokus);

#ifdef I_FACE
		if (cfg.xi_face)
		{
			sprintf(cpom , "%d/%d" , cfg.actual_url + 1, cfg.total_cnt);
			iface_set_counter(cpom);

			iface_set_url(pstr);

			iface_set_what("");
		}
#endif
		xprintf(1 , gettext("URL: %5d of %5d  %s\n") , cfg.actual_url + 1, 
				cfg.total_cnt , pstr);

		if (check_lim)
		{
			if (urlr->status & URL_PROCESSED)
			{
				xprintf(1 , gettext("Allready processed\n"));
				cfg.errcode = ERR_PROCESSED;
				SETNEXTURL;
			}

			if (urlr->status & URL_USER_DISABLED)
			{
				xprintf(1 , gettext("Disallowed by user\n"));
				cfg.errcode = ERR_UDISABLED;
				SETNEXTURL;
			}


			if (!prottable[urlr->type].supported || 
			    (urlr->type == FTP && urlr->p.ftp.dir && !cfg.condition.ftpdir) ||
			    (urlr->parent_url[0] && !url_append_condition(urlr , FALSE)))
			{ 
				xprintf(1 , gettext("Disallowed by rules\n"));

				urlr->status |= URL_REJECTED;
				cfg.errcode = ERR_RDISABLED;
				SETNEXTURL;
			}

		      	iface_set_what(gettext("Checking robots.txt"));

			cfg.report_size = FALSE;
			if (!check_robots(urlr))
			{
				xprintf(1 , gettext("Disallowed by \"robots.txt\"\n"));

				urlr->status |= URL_REJECTED;
				cfg.errcode = ERR_RDISABLED;
				SETNEXTURL;
			}
		}
	
		_Xt_Serve

		cfg.report_size = TRUE;

		if (cfg.mode == MODE_SYNC)
		{
			pp = url_to_filename(urlr);
			if (!stat(pp , &estat) && !S_ISDIR(estat.st_mode))
			{
				atm = time(NULL) - 86400 * cfg.ddays;
				if (estat.st_mtime < atm)
					docu.dtime = new_tm(gmtime(&estat.st_mtime));
				else
				{
					xprintf(1 , gettext("No transfer - file not expired\n"));

					_free(pp);
					urlr->status |= URL_REJECTED;
					cfg.errcode = ERR_RDISABLED;
					SETNEXTURL;
				}
			}
			_free(pp);
		}

		if (cfg.show_time)
		{
			atm = time(NULL);
			strftime(cpom , sizeof(cpom) , "%H:%M:%S" , localtime(&atm));		
			xprintf(1 , gettext("Starting time :  %s\n") , cpom);
		}

#ifdef I_FACE
		if (!cfg.stop && !cfg.rbreak)
		{
#endif

		_Xt_Serve

		if (urlr->type == FTP &&
		    urlr->extension && 
		    ((ftp_url_extension *)urlr->extension)->type == FTP_TYPE_L &&
		    ((ftp_url_extension *)urlr->extension)->slink)
		{
			ftp_make_symlink(urlr);
			urlr->status |= URL_PROCESSED;
			cfg.errcode = ERR_NOERROR;
			SETNEXTURL;
		}

		if (download_document(&docu,(cfg.prepurlstr && cfg.mode == MODE_SYNC), FALSE))
		{
			if (cfg.show_time)
			{
				atm = time(NULL);
				strftime(cpom , sizeof(cpom) , "%H:%M:%S" , localtime(&atm));
				xprintf(1 , gettext("Ending time :    %s\n") , cpom);
			}

			_Xt_Serve

			remove_lock();

			if (cfg.errcode != ERR_FTP_BDIR)
				make_clean_dir(urlr);

			report_error(cfg.errcode , "download");
			_free(docu.contents);
			_free(docu.dtime);

			if (((nreget < cfg.nreget) &&
				(cfg.errcode == ERR_HTTP_TRUNC || cfg.errcode == ERR_FTP_TRUNC))
				|| (nredir < cfg.nredir && cfg.errcode == ERR_HTTP_REDIR)
				|| (cfg.errcode == ERR_HTTP_AUTH))
			{
				if (cfg.errcode == ERR_HTTP_REDIR)
				{
					urlr->status |= URL_PROCESSED;
					if (urlr->moved_to->status & URL_PROCESSED)
					{
						SETNEXTURL;
					}
					else
					{
#ifdef I_FACE
						if (cfg.xi_face)
							icons_set_for_doc(&docu);
#endif
						urlr = urlr->moved_to;
					}
				}
				if (cfg.errcode == ERR_HTTP_TRUNC)
				{
					urlr->status |= URL_TRUNCATED;
					_free(docu.etag);

					docu.etag = get_mime_param_val_str("ETag:" , docu.mime);
					if (!docu.etag) docu.etag = get_mime_param_val_str("Last-Modified" , docu.mime);
				}

				if (cfg.errcode == ERR_HTTP_AUTH)
				{
					int proxy_auth;
					http_digest_info *digest;

					if ((digest = http_digest_parse(docu.mime , urlr , &proxy_auth)))
					{
						if (proxy_auth)
						{
							if ((num_proxy_auth < 2) &&
								cfg.http_proxy_pass && 
								cfg.http_proxy_user)
							{
								num_proxy_auth++;
								if (cfg.auth_proxy_digest)
									http_digest_deep_free(cfg.auth_proxy_digest);
								cfg.auth_proxy_digest = digest;
							}
							else
							{
								if (cfg.auth_proxy_digest)
									http_digest_deep_free(cfg.auth_proxy_digest);
								http_digest_deep_free(digest);
								cfg.auth_proxy_digest = NULL;
								urlr->status |= URL_ERR_REC;
								SETNEXTURL;
							}
						}
						else
						{
							if ((num_auth < 2) && 
								url_get_pass(urlr , digest->realm) && 
								url_get_user(urlr , digest->realm))
							{
								num_auth++;
								if (cfg.auth_digest)
									http_digest_deep_free(cfg.auth_digest);
								cfg.auth_digest = digest;
							}
							else
							{
								if (cfg.auth_digest)
									http_digest_deep_free(cfg.auth_digest);
								http_digest_deep_free(digest);
								cfg.auth_digest = NULL;
								urlr->status |= URL_ERR_REC;
								SETNEXTURL;
							}
						}
					}
					else
					{
						urlr->status |= URL_PROCESSED;
						urlr->status |= URL_ERR_REC;
						SETNEXTURL;
					}
				}

				_free(docu.mime);
				_free(docu.type_str);

				nreget += (cfg.errcode == ERR_HTTP_TRUNC || 
					   cfg.errcode == ERR_FTP_TRUNC) &&
					   cfg.mode != MODE_SREGET;
				nredir +=  cfg.errcode == ERR_HTTP_REDIR;
				_free(pstr);
				continue;
			}

			if (cfg.errcode == ERR_FTP_UNKNOWN ||
			    cfg.errcode == ERR_FTP_CONNECT ||
			    cfg.errcode == ERR_FTP_DATACON ||
			    cfg.errcode == ERR_HTTP_UNKNOWN ||
			    cfg.errcode == ERR_HTTP_CONNECT ||
			    cfg.errcode == ERR_HTTP_SNDREQ ||
			    cfg.errcode == ERR_HTTP_SERV ||
			    cfg.errcode == ERR_READ ||
			    cfg.errcode == ERR_ZERO_SIZE ||
			    cfg.errcode == ERR_GOPHER_CONNECT)
			{
				urlr->status |= URL_ERR_REC;
				pokus ++;
				/*** novy pokus len ak to ma zmysel !!!! ***/
				if (pokus >= cfg.nretry)
				{
					urlr->status |= URL_PROCESSED;
					SETNEXTURL;
				}
				_free(pstr);
				_free(docu.mime);
				_free(docu.type_str);
				continue;
			}
			else if (cfg.errcode == ERR_LOCKED)
			{
				if ((cfg.actual_url + 1) == cfg.total_cnt)
				{
					xprintf(1 , gettext("last document locked -> sleeping for 5 seconds\n"));
					my_sleep(5);
				}
				reschedule_url(urlr);
				SETNEXTURL;
			}
			else if (cfg.errcode == ERR_BIGGER ||
				 cfg.errcode == ERR_NOMIMET || cfg.errcode == ERR_OUTTIME ||
				 cfg.errcode == ERR_SCRIPT_DISABLED)
			{
				urlr->status |= URL_PROCESSED;
				urlr->status |= URL_ERR_REC;
				SETNEXTURL;

			}
			else
			{
				/*** remove improper documents if required ***/
				if ((cfg.remove_old && cfg.mode == MODE_SYNC) &&
				    (((cfg.errcode == ERR_FTP_GET ||
				     cfg.errcode == ERR_FTP_BDIR ||
				     cfg.errcode == ERR_FTP_NODIR) && 
				     	cfg.ftp_respc == 550) ||
				     cfg.errcode == ERR_HTTP_NFOUND))
				{
					remove_document(docu.doc_url);
				}

				cfg.fail_cnt++;

				urlr->status |= URL_ERR_UNREC;
				urlr->status |= URL_PROCESSED;

				SETNEXTURL;
			}
		}

		_Xt_Serve

		if (urlr->status & URL_TRUNCATED)
			urlr->status &= ~URL_TRUNCATED;

		if (urlr->status & URL_ERR_REC)
			urlr->status &= ~URL_ERR_REC;
		

		if (cfg.recv_cookies && docu.mime)
		{
			int i;
			char *cookie_field;

			for (i = 0 ; (cookie_field = get_mime_n_param_val_str("Set-Cookie:" , docu.mime , i)) ; i++)
			{
				cookie_insert_field(cookie_field , urlr);
				_free(cookie_field);
			}
		}

		_Xt_Serve

		if (cfg.update_cookies && cfg.cookie_changed > 10)
		{
			cookie_update_ns();
		}
		
		if (cfg.show_time)
		{
			atm = time(NULL);
			strftime(cpom , sizeof(cpom) , "%H:%M:%S" , localtime(&atm));
			xprintf(1 , gettext("Ending time :    %s\n") , cpom);
		}

		report_error(cfg.errcode,"download");		

		_Xt_Serve

		if (docu.contents)
		{
			if (docu.is_html)
			{
				int len;
				char *newcont;

				iface_set_what(gettext("Searching for links"));

				if (cfg.rewrite_links)
					relocate_html_doc(&docu);

				_Xt_Serve

				if (cfg.mode != MODE_SREGET)
				{
					pom = html_get_all_links(&docu ,
						cfg.mode == MODE_SINGLE);

#ifdef WITH_TREE
#ifdef _GTK_FEATURES_1_2
					if (cfg.xi_face)
						gtk_clist_freeze(GTK_CLIST(cfg.gtk.tree_widget));
#endif
#ifdef X_FACE
					if (cfg.xi_face)
						TreeListDontDoLayout(cfg.X.tree_widget);
#endif
#endif
					cat_links_to_url_list(pom);
#ifdef WITH_TREE
#ifdef _GTK_FEATURES_1_2
					if (cfg.xi_face)
						gtk_clist_thaw(GTK_CLIST(cfg.gtk.tree_widget));
#endif
#ifdef X_FACE
					if (cfg.xi_face)
						TreeListDoLayout(cfg.X.tree_widget);
#endif
#endif
				}

				_Xt_Serve

				if (cfg.rewrite_links)
				{

					len = html_remote_to_local_links(&newcont , &docu);
					_free(docu.contents);
					docu.contents = newcont;
					docu.size = len;
				}
			}
			store_stat = 0;

			if ((docu.doc_url->type != FILET) && !(docu.doc_url->status & URL_REDIRECT) && (cfg.mode != MODE_NOSTORE))
			{
				iface_set_what(gettext("Storing document"));

				store_stat = store_document(&docu,TRUE);

				if (store_stat)
					xprintf(1 , gettext("Store failed\n"));
			}

			_Xt_Serve

			remove_lock();

			if ((docu.doc_url->type !=  FILET) && !(docu.doc_url->status & URL_REDIRECT) 
				&& (cfg.mode != MODE_NOSTORE) && docu.doc_url->parent_url)
			{
				if (cfg.rewrite_links && !store_stat)
				{
					iface_set_what(gettext("Rewriting links"));
					rewrite_parents_links(docu.doc_url , NULL);
				}
			}
		}
		else
		{

			remove_lock();
			if (cfg.rewrite_links && (cfg.mode != MODE_NOSTORE) &&
				(docu.doc_url->type !=  FILET) && 
				docu.doc_url->parent_url)
			{
				iface_set_what(gettext("Rewriting parent document links"));
				rewrite_parents_links(docu.doc_url , NULL);
			}
		}

		urlr->status |= URL_DOWNLOADED;
		urlr->status |= URL_PROCESSED;
		SETNEXTURL;
#ifdef I_FACE
	}
#endif
	}
}


/*********************************************/
/* rekurzivne prechadzanie stromu dokumentov */
/*********************************************/

void recurse()
{

	if (cfg.urlstack == NULL) return ;

	cfg.ftp_control = NULL;
	cfg.s_sock = NULL;

/**** obsluzenie vsetkych URL v zozname ****/
	while(cfg.urlstack[cfg.actual_url] && !cfg.stop)
	{
		process_url(cfg.urlstack[cfg.actual_url] , TRUE);
		if (!cfg.rbreak) 
			cfg.actual_url++;
	}
#ifdef I_FACE
        if (cfg.xi_face)
        {
		char cpom[2048];

		iface_set_what(gettext("Done"));
		sprintf(cpom , "%d/%d" , cfg.actual_url , cfg.total_cnt);
		iface_set_counter(cpom);
	}
#endif
	/**** uzatvorenie FTP spojenia ak bol preruseny prenos ****/
	if (cfg.ftp_control)
	{
                bufio_write(cfg.ftp_control , "QUIT\r\n" , 6);
                shutdown(bufio_getfd(cfg.ftp_control) , 2);
                bufio_close(cfg.ftp_control);
                cfg.ftp_control = 0;
	}

	if (cfg.update_cookies && cfg.cookie_changed)
	{
		cookie_update_ns();
	}

}

void get_urls_to_resume(dirname)
char *dirname;
{
	DIR *dir;
	struct dirent *dent;
	char next_dir[PATH_MAX];
	struct stat estat;
	url *purl;

	if (!(dir = opendir(dirname)))
	{
		xperror(dirname);
		return;
	}

	iface_set_what(gettext("Searching for files to resume"));

	while((dent = readdir(dir)))
	{
		_Xt_Serve

		sprintf(next_dir , "%s/%s" , dirname , dent->d_name);
		if (!strcmp(dent->d_name , ".")) continue;
		if (!strcmp(dent->d_name , "..")) continue;		
		if (stat(next_dir , &estat))
		{
			xperror(next_dir);
			continue;
		}

		if (S_ISDIR(estat.st_mode))
		{
			get_urls_to_resume(next_dir);
		}
		else if (!strncmp(".in_" , dent->d_name , 4))
		{
			xprintf(1 , gettext("Adding %s to resume list\n") , next_dir);
			sprintf(next_dir , "%s/%s" , dirname , dent->d_name + 4);
			if ((purl = filename_to_url(next_dir)))
			{
				append_url_to_list(purl);
			}
		}

#ifdef I_FACE
		if (cfg.xi_face)
		{
			if (cfg.rbreak || cfg.stop)
			{
				closedir(dir);
				return;
			}
		}
#endif
	}

	closedir(dir);
}

void get_urls_to_synchronize(dirname)
char *dirname;
{
	DIR *dir;
	struct dirent *dent;
	char next_dir[PATH_MAX];
	struct stat estat;
	url *purl;


	if (!(dir = opendir(dirname)))
	{
		xperror(dirname);
		return;
	}

	iface_set_what(gettext("Searching for documents to synchronize"));

	while((dent = readdir(dir)))
	{
		_Xt_Serve

		sprintf(next_dir , "%s/%s" , dirname , dent->d_name);
		if (!strcmp(dent->d_name , ".")) continue;
		if (!strcmp(dent->d_name , "..")) continue;		
		if (stat(next_dir , &estat))
		{
			xperror(next_dir);
			continue;
		}

		if (S_ISDIR(estat.st_mode))
		{
			get_urls_to_synchronize(next_dir);
		}
		else if (!strncmp(".in_" , dent->d_name , 4))
		{
			xprintf(1 , gettext("Adding %s to sync list\n") , next_dir);
			sprintf(next_dir , "%s/%s" , dirname , dent->d_name + 4);
			if ((purl = filename_to_url(next_dir)))
			{
				append_url_to_list(purl);
			}
		}
		else
		{
			
			if ((purl = filename_to_url(next_dir)))
			{
				xprintf(1 , gettext("Adding %s to sync list\n") , next_dir);
				append_url_to_list(purl);
			}
		}

#ifdef I_FACE
		if (cfg.xi_face)
		{
			if (cfg.rbreak || cfg.stop)
			{
				closedir(dir);
				return;
			}
		}
#endif
	}

	closedir(dir);
}

