/***************************************************************************/
/* 		This code is part of WWW graber called pavuk		   */
/*		Copyright (c) 1997,1998,1999 Ondrejicka Stefan		   */
/*		(ondrej@idata.sk)					   */
/*		Distributed under GPL 2 or later			   */
/***************************************************************************/

#ifndef _tools_h_
#define _tools_h_

#include <time.h>
#include <stdlib.h>

typedef char bool;

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE 1
#endif


#define _free(ptr) if(ptr){ free(ptr); ptr = NULL;}

#define NUM_ELEM(x)	((unsigned int) (sizeof(x) / sizeof(x[0])))

#if NeedFunctionPrototypes
extern char *upperstr(char *);
extern char *lowerstr(char *);
extern char *new_string(char *);
extern char *new_n_string(char * , int);
extern int makealldirs(char *);
extern char *get_abs_file_path(char *);
extern char *get_relative_path(char *,char *);
extern char *get_extension(char *);
extern char **make_list(char *,char *);
extern bool is_in_list(char * , char **);
extern char *strtokc(char * , int);
extern char *strfindnchr(char * , int , int);
extern void *_malloc(int);
extern void *_realloc(void *, int);
extern int my_read(int , char * , int);
extern int my_readln(char * , int , int);
extern int my_write(int , char * , int);
extern int _selectr(int , int);
extern int _selectw(int , int);
extern int  get_line(char * , int , int);
extern bool file_is_html(char *);
extern bool ext_is_html(char *);
extern long int _atoi(char *);
extern void remove_lock();
extern char * _strtrchr(char * , int , int);
extern void xprintf(int , char * , ...);
extern void xperror(char *);
extern void xherror(char *);
extern void show_progres(int);
extern int unlink_recursive(char *);
extern unsigned int hash_func(char * , int);
extern int str_is_in_list(int , char * , ...);
extern char *cvt_win32_to_unix_path(char *);
extern int copy_fd_to_file(int , char *);
extern void my_msleep(unsigned int);
#ifdef NO_SETENV
extern int my_setenv(char *, char *, int);
#endif
#ifndef I_FACE
#define my_sleep sleep
#else
extern void my_sleep(unsigned int);
#endif
extern int my_flock(int , int);
#ifdef HAVE_FCNTL_FLOCK
extern int my_funlock(int);
#endif
#else
extern char *upperstr();
extern char *lowerstr();
extern char *new_string();
extern char *new_n_string();
extern int makealldirs();
extern char *get_abs_file_path();
extern char *get_relative_path();
extern char *get_extension();
extern char **make_list();
extern bool is_in_list();
extern char *strtokc();
extern char *strfindnchr();
extern void *_malloc();
extern void *_realloc();
extern int my_read();
extern int my_readln();
extern int my_write();
extern int _selectr();
extern int _selectw();
extern int get_line();
extern bool file_is_html();
extern bool ext_is_html();
extern long int _atoi();
extern void remove_lock();
extern char * _strtrchr();
extern void xprintf();
extern void xperror();
extern void xherror();
extern void show_progres();
extern int unlink_recursive();
extern unsigned int hash_func();
extern int str_is_in_list();
extern char *cvt_win32_to_unix_path();
extern int copy_fd_to_file();
extern void my_msleep();
#ifdef NO_SETENV
extern int my_setenv();
#endif
#ifndef I_FACE
#define my_sleep sleep
#else
extern void my_sleep();
#endif
extern int my_flock();
#ifdef HAVE_FCNTL_FLOCK
extern int my_funlock();
#endif
#endif

#endif
