/***************************************************************************/
/* 		This code is part of WWW graber called pavuk		   */
/*		Copyright (c) 1997,1998,1999 Ondrejicka Stefan		   */
/*		(ondrej@idata.sk)					   */
/*		Distributed under GPL 2 or later			   */
/***************************************************************************/

#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <time.h>
#include <stdio.h>

#ifdef HAVE_SYS_MODE_H
#include <sys/mode.h>
#endif

#include "config.h"

#ifdef I_FACE

#include "tools.h"
#include "html.h"


#ifdef GTK_FACE

/*****************************************************************************/
/*			GTK GUI abstracion macros			     */ 
/*****************************************************************************/

#include "gtkscalendar.h"

#define _IFT_ gtk

#define SET_LIST(w,l) \
{\
	char **p = l;\
	gtk_widget_unmap(w);\
	gtk_list_remove_items (GTK_LIST (w) , GTK_LIST(w)->children);\
        if (p) while(*p)\
        {\
        	GtkWidget *list_item;\
		list_item = gtk_list_item_new_with_label (*p);\
		gtk_container_add (GTK_CONTAINER (w), list_item);\
		gtk_widget_show (list_item);\
  		p++;\
	}\
	gtk_widget_map(w);\
	gtk_widget_show(w);\
}

#define SET_DLLIST(w,l) \
{\
	dllist *p = l;\
	gtk_widget_unmap(w);\
	gtk_list_remove_items (GTK_LIST (w) , GTK_LIST(w)->children);\
        if (p) while(p)\
        {\
        	GtkWidget *list_item;\
		list_item = gtk_list_item_new_with_label ((char *)p->data);\
		gtk_container_add (GTK_CONTAINER (w), list_item);\
		gtk_widget_show (list_item);\
  		p = p->next;\
	}\
	gtk_widget_map(w);\
	gtk_widget_show(w);\
}

#define SET_NUM(w,v) \
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(w) , (gfloat)v);\
	gtk_signal_emit_by_name(GTK_OBJECT(gtk_spin_button_get_adjustment(GTK_SPIN_BUTTON(w))) , "value_changed");

#define SET_TEXT(w,t) \
	if (t) gtk_entry_set_text(GTK_ENTRY(w) , t);\
	else gtk_entry_set_text(GTK_ENTRY(w) , "");

#define SET_BOOL(w,v) \
	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(w) , v);


#define SET_HTML_TAGS \
{\
	GList *chlist;\
	int *statpointer;\
	\
	for(chlist = GTK_BOX(cfg.gtk.html_tags)->children ; chlist ; chlist = chlist->next)\
	{\
		statpointer = gtk_object_get_user_data(\
				GTK_OBJECT(((struct _GtkBoxChild *)chlist->data)->widget));\
	\
		SET_BOOL(((struct _GtkBoxChild *)chlist->data)->widget ,\
			!(*statpointer & LINK_DISABLED));\
	}\
}

#define SET_COMBO_IDX(w , i) \
  	gtk_option_menu_set_history(GTK_OPTION_MENU(w) , i);

#ifdef _GTK_FEATURES_1_2
#define SET_CALENDAR(w , ltime) \
	gtk_calendar_select_month(GTK_CALENDAR(w) , \
		ltime->tm_mon , ltime->tm_year);\
	gtk_calendar_select_day(GTK_CALENDAR(w) , \
		ltime->tm_mday);
#else
#define SET_CALENDAR(w , ltime) \
	gtk_scalendar_set_date(GTK_SCALENDAR(w) , \
		ltime->tm_mday , ltime->tm_mon , ltime->tm_year);
#endif /* _GTK_FEATURES_1_2 */

#define SET_C_EXTRAS \
	SET_BOOL(cfg. _IFT_ .http_schgr[cfg.auth_scheme - 1] , TRUE);\
	SET_BOOL(cfg. _IFT_ .httpp_schgr[cfg.proxy_auth_scheme - 1] , TRUE);\
	SET_BOOL(cfg. _IFT_ .ftpmodegr[(int)cfg.ftp_activec] , TRUE);



#define GET_LIST(w,l) \
{\
	GList *dlist = GTK_LIST(w)->children;\
	char **p=l;\
	int n=0;\
	\
	while(l && *p) _free(*p);\
	_free(l);\
	l = NULL;\
	while(dlist)\
	{\
		l = (char **)_realloc(l , (n + 2) * sizeof(char *));\
		l[n] = new_string(GTK_LABEL(((GList *)gtk_container_children(GTK_CONTAINER(dlist->data)))->data)->label);\
		l[n+1] = NULL;\
		n++;\
		dlist = dlist->next;\
	}\
}

#define GET_DLLIST(w,l) \
{\
	GList *dlist = GTK_LIST(w)->children;\
	\
	while(l) {_free(l->data) ; l = dllist_remove_entry(l , l);}\
	while(dlist)\
	{\
		l = dllist_append(l , new_string(GTK_LABEL(((GList *)gtk_container_children(GTK_CONTAINER(dlist->data)))->data)->label));\
		dlist = dlist->next;\
	}\
}

#define GET_BOOL(w,v) \
		(v = GTK_TOGGLE_BUTTON(w)->active)

#define GET_NUM(w,v) \
		(v = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(w)))

#define GET_STR(w,s) \
	_free(s);\
	s = new_string(gtk_entry_get_text (GTK_ENTRY(w)));\
	if (!(s && *s))\
	{\
		_free(s);\
	}

#define GET_S_STR(w,s) \
	s = new_string(gtk_entry_get_text (GTK_ENTRY(w)));\
	if (!(s && *s))\
	{\
		_free(s);\
	}

#define GET_HTML_TAGS \
{\
	GList *chlist;\
	int *statpointer;\
	\
	for(chlist = GTK_BOX(cfg.gtk.html_tags)->children ; chlist ; chlist = chlist->next)\
	{\
		statpointer = gtk_object_get_user_data(\
			GTK_OBJECT(((struct _GtkBoxChild *)chlist->data)->widget));\
		\
		if (GET_BOOL(((struct _GtkBoxChild *)chlist->data)->widget , b))\
			*statpointer &= ~LINK_DISABLED;\
		else\
			*statpointer |= LINK_DISABLED;\
	}\
}

#ifdef _GTK_FEATURES_1_2
#define GET_DATE(w , ftm) \
	gtk_calendar_get_date(GTK_CALENDAR(w) ,\
		&ftm.tm_year , &ftm.tm_mon , &ftm.tm_mday);\
	ftm.tm_year -= 1900;
#else
#define GET_DATE(w , ftm) \
	ftm.tm_mday = GTK_SCALENDAR(w)->day;\
	ftm.tm_mon = GTK_SCALENDAR(w)->month;\
	ftm.tm_year = (GTK_SCALENDAR(w)->year >= 1900) ? \
		GTK_SCALENDAR(w)->year - 1900 : \
		GTK_SCALENDAR(w)->year;
#endif /* _GTK_FEATURES_1_2 */

#define GET_C_EXTRAS \
	if (GET_BOOL(cfg.gtk.http_schgr[0] , cfg.auth_scheme))\
		cfg.auth_scheme = 1;\
	else if (GET_BOOL(cfg.gtk.http_schgr[1] , cfg.auth_scheme))\
		cfg.auth_scheme = 2;\
	else if (GET_BOOL(cfg.gtk.http_schgr[2] , cfg.auth_scheme))\
		cfg.auth_scheme = 3;\
	if (GET_BOOL(cfg.gtk.httpp_schgr[0] , cfg.proxy_auth_scheme))\
		cfg.proxy_auth_scheme = 1;\
	else if (GET_BOOL(cfg.gtk.httpp_schgr[1] , cfg.proxy_auth_scheme))\
		cfg.proxy_auth_scheme = 2;\
	else if (GET_BOOL(cfg.gtk.httpp_schgr[2] , cfg.proxy_auth_scheme))\
		cfg.proxy_auth_scheme = 3;\
	GET_BOOL(cfg.gtk.ftpmodegr[1] , cfg.ftp_activec);


#endif /* GTK_FACE */

#ifdef X_FACE

/*****************************************************************************/
/*			Xt GUI abstracion macros			     */
/*****************************************************************************/

#include "tools.h"
#include "html.h"
#include <Nws/MultiColP.h>

#define _IFT_ X

#define ForAllChildren(cw, child) \
        for ( (child) = (cw)->composite.children ; \
                (child) < ((cw)->composite.children + \
                (cw)->composite.num_children ) ; \
                (child)++ )

#define SET_LIST(w,l) \
{\
	ListStruct plist;\
	char **p;\
	\
 	p = l;\
	ListChange(w , NULL , 0 , True);\
        if (p) while(*p)\
        {\
		plist.sensitive = True;\
		plist.left_icon = NULL;\
		plist.right_icon = NULL;\
		plist.related_info = NULL;\
        	plist.label = *p;\
  		ListAppendItems(w , &plist , 1);\
  		p++;\
	}\
}

#define SET_DLLIST(w,l) \
{\
	ListStruct plist;\
	dllist *p;\
	\
 	p = l;\
	ListChange(w , NULL , 0 , True);\
        if (p) while(p)\
        {\
		plist.sensitive = True;\
		plist.left_icon = NULL;\
		plist.right_icon = NULL;\
		plist.related_info = NULL;\
        	plist.label = (char *) p->data;\
  		ListAppendItems(w , &plist , 1);\
  		p = p->next;\
	}\
}

#define SET_NUM(w,v) \
	XtVaSetValues(w , XtNvalue , v , NULL);

#define SET_TEXT(w,t) \
	EntryLineSetText(w,t);

#define SET_BOOL(w,v) \
	XtVaSetValues(w , XtNon , v , NULL);

#define SET_HTML_TAGS \
{\
	int *statpointer;\
	Widget *child;\
\
	ForAllChildren(((MultiColWidget)cfg.X.html_tags) , child)\
	{\
		XtVaGetValues((Widget)*child , XtNuser_data , &statpointer , NULL);\
		XtVaSetValues((Widget)*child ,\
			XtNon , !(*statpointer & LINK_DISABLED) , NULL);\
	}\
}

#define SET_CALENDAR(w , ltime) \
	XtVaSetValues(w , XtNtime , ltime , NULL);

#define SET_COMBO_IDX(w , i) \
	ComboSetIndex(w , i);

#define SET_C_EXTRAS \
	RadioGroupSetSelected(cfg.X.auth_sw , cfg.auth_scheme);\
	RadioGroupSetSelected(cfg.X.proxy_auth_sw , cfg.proxy_auth_scheme);\
	RadioGroupSetSelected(cfg.X.ftp_data_sw , cfg.ftp_activec);


#define GET_LIST(w,l) \
{\
	ListStruct *plist;\
	int num,i;\
	\
	for(i = 0; l && l[i] ; i++) _free(l[i]);\
	_free(l);\
	XtVaGetValues(w , XtNlist , &plist , XtNnum_entry , &num , NULL);\
	if (num > 0)\
	{\
		l = (char **) _malloc((num + 1) * sizeof(char *));\
		l[num] = NULL;\
		for(i = 0 ; i < num ; i++)\
		{\
			l[i] = new_string(plist[i].label);\
		}\
	}\
}

#define GET_DLLIST(w,l) \
{\
	ListStruct *plist;\
	int num,i;\
	\
	while(l) l = dllist_remove_entry(l , l);\
	XtVaGetValues(w , XtNlist , &plist , XtNnum_entry , &num , NULL);\
	if (num > 0)\
	{\
		for(i = 0 ; i < num ; i++)\
		{\
			l = dllist_append(l , new_string(plist[i].label));\
		}\
	}\
}

#define GET_BOOL(w,b) \
	XtVaGetValues(w , XtNon , &b , NULL);

#define GET_NUM(w,v) \
	(v = NumberEntryGetValue(w))

#define GET_STR(w,s) \
	_free(s);\
	s = new_string(EntryLineGetText(w));\
	if (!(s && *s))\
	{\
		_free(s);\
	}

#define GET_S_STR(w,s) \
	s = new_string(EntryLineGetText(w));\
	if (!(s && *s))\
	{\
		_free(s);\
	}

#define GET_HTML_TAGS \
{\
	int *statpointer;\
	Widget *child;\
	Boolean pb;\
	\
	ForAllChildren(((MultiColWidget)cfg.X.html_tags) , child)\
	{\
		XtVaGetValues((Widget)*child ,\
			XtNuser_data , &statpointer ,\
			XtNon , &pb ,\
			NULL);\
		\
		if (pb)\
			*statpointer &= ~LINK_DISABLED;\
		else\
			*statpointer |= LINK_DISABLED;\
	}\
}

#define GET_DATE(w , ftm) \
{\
	struct tm *ptm;\
	\
	XtVaGetValues(w , XtNtime , &ptm , NULL);\
	ftm.tm_mday = ptm->tm_mday;\
	ftm.tm_mon = ptm->tm_mon;\
	ftm.tm_year = (ptm->tm_year >= 1900) ? ptm->tm_year - 1900 : ptm->tm_year;\
}

#define GET_C_EXTRAS \
{\
	int id;\
	\
	XtVaGetValues(RadioGroupGetSelected(cfg.X.auth_sw) , XtNid , &id , NULL);\
	cfg.auth_scheme = id;\
	XtVaGetValues(RadioGroupGetSelected(cfg.X.proxy_auth_sw) , XtNid , &id , NULL);\
	cfg.proxy_auth_scheme = id;\
	XtVaGetValues(RadioGroupGetSelected(cfg.X.ftp_data_sw) , XtNid , &id , NULL);\
	cfg.ftp_activec = id;\
}


#endif /* X_FACE */


void xset_cfg_values_lim()
{
	char pom[2048];
	struct tm *ltime;
	time_t t;
	char **pp;


	SET_HTML_TAGS;

	SET_BOOL(cfg. _IFT_ .ftp_html , cfg.ftp_html);

	SET_BOOL(cfg. _IFT_ .leaved_sw , cfg.condition.dont_leave_dir);

	SET_BOOL(cfg. _IFT_ .leaves_sw , cfg.condition.dont_leave_site);

	SET_BOOL(cfg. _IFT_ .ftpd_sw , cfg.condition.ftpdir);

	SET_BOOL(cfg. _IFT_ .cgi_sw , cfg.condition.cgi);

	SET_BOOL(cfg. _IFT_ .hosts_sw , cfg.condition.allow_site);

	SET_BOOL(cfg. _IFT_ .domain_sw , cfg.condition.allow_domain);

	SET_BOOL(cfg. _IFT_ .mime_sw , cfg.condition.allow_mime);

	SET_BOOL(cfg. _IFT_ .prefix_sw , cfg.condition.allow_prefix);

	SET_BOOL(cfg. _IFT_ .sufix_sw , cfg.condition.allow_sufix);

	SET_BOOL(cfg. _IFT_ .robots_sw , cfg.condition.allow_robots);

	SET_NUM (cfg. _IFT_ .maxlev_label , cfg.condition.max_levels);

	SET_NUM (cfg. _IFT_ .maxdoc_label , cfg.condition.max_documents);

	SET_NUM (cfg. _IFT_ .leave_level , cfg.condition.leave_level);

	SET_NUM (cfg. _IFT_ .maxsize_label , cfg.condition.max_size);
	SET_NUM (cfg. _IFT_ .min_size , cfg.condition.min_size);

	pom[0] = '\0';
	for (pp = cfg.condition.pattern ; pp && *pp ; pp++)
	{
		if (pp != cfg.condition.pattern)
		{
			strcat(pom , ",");
			strcat(pom , *pp);
		}
		else strcpy(pom , *pp);
	}

	SET_TEXT (cfg. _IFT_ .pattern_label , pom);

	pom[0] = '\0';
	for (pp = cfg.condition.skip_pattern ; pp && *pp ; pp++)
	{
		if (pp != cfg.condition.skip_pattern)
		{
			strcat(pom , ",");
			strcat(pom , *pp);
		}
		else strcpy(pom , *pp);
	}

	SET_TEXT (cfg. _IFT_ .skip_pattern , pom);

	pom[0] = '\0';
	for (pp = cfg.condition.url_pattern ; pp && *pp ; pp++)
	{
		if (pp != cfg.condition.url_pattern)
		{
			strcat(pom , ",");
			strcat(pom , *pp);
		}
		else strcpy(pom , *pp);
	}

	SET_TEXT (cfg. _IFT_ .url_pattern_label , pom);

	pom[0] = '\0';
	for (pp = cfg.condition.skip_url_pattern ; pp && *pp ; pp++)
	{
		if (pp != cfg.condition.skip_url_pattern)
		{
			strcat(pom , ",");
			strcat(pom , *pp);
		}
		else strcpy(pom , *pp);
	}

	SET_TEXT (cfg. _IFT_ .skip_url_pattern , pom);

	SET_TEXT (cfg. _IFT_ .en_uexit , cfg.condition.uexit);

	SET_LIST(cfg. _IFT_ .hosts_list , cfg.condition.sites);

	SET_LIST(cfg. _IFT_ .domain_list , cfg.condition.domains);

	SET_LIST(cfg. _IFT_ .sufixlist , cfg.condition.sufix);	

	SET_LIST(cfg. _IFT_ .prefixlist , cfg.condition.dir_prefix);

	SET_LIST(cfg. _IFT_ .amimelist , cfg.condition.mime);

	SET_BOOL(cfg. _IFT_ .btime_sw , !(cfg.condition.btime == 0));	
	t = time(NULL);

	if (cfg.condition.btime)
		ltime = localtime(&cfg.condition.btime);
	else
		ltime = localtime(&t);

	ltime->tm_year += 1900;

	SET_CALENDAR(cfg. _IFT_ .btime_cal , ltime);
#ifndef _GTK_FEATURES_1_2
	SET_COMBO_IDX(cfg. _IFT_.btime_mon , ltime->tm_mon);
	SET_NUM(cfg. _IFT_ .btime_yentry , ltime->tm_year);
#endif
	SET_NUM(cfg. _IFT_ .btime_h_entry , ltime->tm_hour);
	SET_NUM(cfg. _IFT_ .btime_min_entry , ltime->tm_min);

	SET_BOOL(cfg. _IFT_ .etime_sw , !(cfg.condition.etime == 0));	
	if (cfg.condition.etime)
		ltime = localtime(&cfg.condition.etime);
	else
		ltime = localtime(&t);

	ltime->tm_year += 1900;

	SET_CALENDAR(cfg. _IFT_ .etime_cal , ltime);
#ifndef _GTK_FEATURES_1_2
  	SET_COMBO_IDX(cfg. _IFT_ .etime_mon , ltime->tm_mon);
   	SET_NUM(cfg. _IFT_ .etime_yentry , ltime->tm_year);
#endif
	SET_NUM(cfg. _IFT_ .etime_h_entry , ltime->tm_hour);
	SET_NUM(cfg. _IFT_ .etime_min_entry , ltime->tm_min);

	SET_TEXT (cfg. _IFT_ .subdir_label , cfg.subdir);
}


void xset_cfg_values_comm()
{
	SET_TEXT (cfg. _IFT_ .cdir_label , cfg.cache_dir);

	SET_TEXT (cfg. _IFT_ .auth_file_label , cfg.auth_file);

	SET_TEXT (cfg. _IFT_ .en_cookie_file , cfg.cookie_file);

	SET_TEXT (cfg. _IFT_ .index_name , cfg.index_name);

	SET_TEXT (cfg. _IFT_ .store_name , cfg.store_name);

	SET_BOOL(cfg. _IFT_ .check_size , cfg.check_size);
	SET_BOOL(cfg. _IFT_ .store_index , cfg.store_index);

	SET_BOOL(cfg. _IFT_ .preserve_perm , cfg.preserve_perm);
	SET_BOOL(cfg. _IFT_ .preserve_links , cfg.preserve_links);
	SET_BOOL(cfg. _IFT_ .ftp_list , cfg.ftp_list);

	SET_BOOL(cfg. _IFT_ .sw_cookie_send , cfg.send_cookies);
	SET_BOOL(cfg. _IFT_ .sw_cookie_recv , cfg.recv_cookies);
	SET_BOOL(cfg. _IFT_ .sw_cookie_update , cfg.update_cookies);

	SET_BOOL(cfg. _IFT_ .ptime , cfg.preserve_time);

	SET_BOOL(cfg. _IFT_ .oldrm_sw , cfg.remove_old);
	
	SET_BOOL(cfg. _IFT_ .cache_sw , cfg.cache);


	SET_BOOL(cfg. _IFT_ .ftp_sw , cfg.condition.ftp);


	SET_BOOL(cfg. _IFT_ .http_sw , cfg.condition.http);

#ifdef USE_SSL
	SET_BOOL(cfg. _IFT_ .https_sw , cfg.condition.https);
#endif
	SET_BOOL(cfg. _IFT_ .gopher_sw , cfg.condition.gopher);

	SET_BOOL(cfg. _IFT_ .gopher_httpgw , cfg.gopher_via_http);

	SET_BOOL(cfg. _IFT_ .ftp_httpgw , cfg.ftp_via_http);

	SET_BOOL(cfg. _IFT_ .ftp_dirtyp , cfg.ftp_dirtyp);

	SET_BOOL(cfg. _IFT_ .freget_sw , cfg.freget);

	SET_BOOL(cfg. _IFT_ .noreloc_sw , cfg.rewrite_links);

	SET_BOOL(cfg. _IFT_ .enc_sw , cfg.use_enc);

	SET_BOOL(cfg. _IFT_ .auth_reuse_nonce , cfg.auth_reuse_nonce);
	SET_BOOL(cfg. _IFT_ .auth_reuse_proxy_nonce , cfg.auth_reuse_proxy_nonce);

	SET_C_EXTRAS;

#ifdef WITH_TREE
	SET_TEXT (cfg. _IFT_ .browser_label , cfg.browser);
#endif

	SET_TEXT (cfg. _IFT_ .identity , cfg.identity);

	SET_TEXT (cfg. _IFT_ .http_proxyh_label , cfg.http_proxy);

	SET_NUM (cfg. _IFT_ .http_proxyp_label , cfg.http_proxy_port);

	SET_TEXT (cfg. _IFT_ .ftp_proxyh_label , cfg.ftp_proxy);

	SET_NUM (cfg. _IFT_ .ftp_proxyp_label , cfg.ftp_proxy_port);

	SET_TEXT (cfg. _IFT_ .gopher_proxyh_label , cfg.gopher_proxy);

	SET_NUM (cfg. _IFT_ .gopher_proxyp_label , cfg.gopher_proxy_port);

#ifdef USE_SSL
	SET_TEXT (cfg. _IFT_ .ssl_proxyh_label , cfg.ssl_proxy);

	SET_NUM (cfg. _IFT_ .ssl_proxyp_label , cfg.ssl_proxy_port);

	SET_TEXT (cfg. _IFT_ .ssl_cert_file_en , cfg.ssl_cert_file);
	SET_TEXT (cfg. _IFT_ .ssl_key_file_en , cfg.ssl_key_file);
	SET_TEXT (cfg. _IFT_ .ssl_cert_passwd_en , cfg.ssl_cert_passwd);
#endif
	SET_NUM (cfg. _IFT_ .en_cookie_max , cfg.cookies_max);

	SET_NUM (cfg. _IFT_ .base_level_label , cfg.base_level);

	SET_NUM (cfg. _IFT_ .timeout_label , cfg.ctimeout);

	SET_NUM (cfg. _IFT_ .retry_label , cfg.nretry);

	SET_NUM (cfg. _IFT_ .redir_label , cfg.nredir);

	SET_NUM (cfg. _IFT_ .reget_label , cfg.nreget);

	SET_NUM (cfg. _IFT_ .sleep_label , cfg.sleep);

	SET_NUM (cfg. _IFT_ .xloglen_label , cfg.xlogsize);
	
	SET_TEXT (cfg. _IFT_ .log_label , cfg.logfile);

	SET_TEXT (cfg. _IFT_ .slog_label , cfg.short_logfile);

	SET_TEXT (cfg. _IFT_ .auth_label , cfg.name_auth);

	SET_TEXT (cfg. _IFT_ .pass_label , cfg.passwd_auth);

	SET_TEXT (cfg. _IFT_ .proxy_auth_label , cfg.http_proxy_user);

	SET_TEXT (cfg. _IFT_ .proxy_pass_label , cfg.http_proxy_pass);

	SET_BOOL (cfg. _IFT_ .send_from , cfg.send_from);
	SET_TEXT (cfg. _IFT_ .from_label , cfg.from);

	SET_NUM (cfg. _IFT_ .rollback_label , cfg.rollback);

	SET_NUM (cfg. _IFT_ .ddays_label , cfg.ddays);

	SET_LIST(cfg. _IFT_ .langlist , cfg.accept_lang);

	SET_LIST(cfg. _IFT_ .charset_list , cfg.accept_chars);

	SET_DLLIST(cfg. _IFT_ .url_list , cfg.prepurlstr);

	SET_LIST(cfg. _IFT_ .cookie_domain_list , cfg.cookies_disabled_domains);

	SET_TEXT(cfg. _IFT_ .tr_del_chr , cfg.tr_del_chr);
	SET_TEXT(cfg. _IFT_ .tr_str_s1 , cfg.tr_str_s1);
	SET_TEXT(cfg. _IFT_ .tr_str_s2 , cfg.tr_str_s2);
	SET_TEXT(cfg. _IFT_ .tr_chr_s1 , cfg.tr_chr_s1);
	SET_TEXT(cfg. _IFT_ .tr_chr_s2 , cfg.tr_chr_s2);
}


int xget_cfg_values_lim()
{
	struct tm ftm;
	char *p = NULL;
	int i;
	bool b;
	struct stat estat;

	GET_HTML_TAGS;

	GET_STR (cfg. _IFT_ .subdir_label , p);
	if (p && !((stat(p , &estat) >= 0) && S_ISDIR(estat.st_mode)))
	{
		_free(p);
		xprintf(0 , gettext("Bad parameter - Working subdirectory"));
		return -1;
	}
	else
	{
		_free(cfg.subdir);
		if (p) cfg.subdir = get_abs_file_path(p);
		_free(p);
	}

	GET_BOOL(cfg. _IFT_ .ftp_html , cfg.ftp_html);

	GET_BOOL(cfg. _IFT_ .leaves_sw , cfg.condition.dont_leave_site);

	GET_BOOL(cfg. _IFT_ .leaved_sw , cfg.condition.dont_leave_dir);

	GET_BOOL(cfg. _IFT_ .cgi_sw , cfg.condition.cgi);

	GET_BOOL(cfg. _IFT_ .ftpd_sw , cfg.condition.ftpdir);

	GET_BOOL(cfg. _IFT_ .hosts_sw , cfg.condition.allow_site);

	GET_BOOL(cfg. _IFT_ .domain_sw , cfg.condition.allow_domain);

	GET_BOOL(cfg. _IFT_ .mime_sw , cfg.condition.allow_mime);

	GET_BOOL(cfg. _IFT_ .prefix_sw , cfg.condition.allow_prefix);

	GET_BOOL(cfg. _IFT_ .sufix_sw , cfg.condition.allow_sufix);

	GET_BOOL(cfg. _IFT_ .robots_sw , cfg.condition.allow_robots);

        p = NULL;
        GET_STR(cfg. _IFT_ .pattern_label , p);
        for(i = 0; cfg.condition.pattern && cfg.condition.pattern[i] ; i++)
                _free(cfg.condition.pattern[i]);\
        _free(cfg.condition.pattern);
        cfg.condition.pattern = make_list(p , ",");
	_free(p);

        p = NULL;
        GET_STR(cfg. _IFT_ .skip_pattern , p);
        for(i = 0; cfg.condition.skip_pattern && cfg.condition.skip_pattern[i] ; i++)
                _free(cfg.condition.skip_pattern[i]);\
        _free(cfg.condition.skip_pattern);
        cfg.condition.skip_pattern = make_list(p , ",");
	_free(p);

        p = NULL;
        GET_STR(cfg. _IFT_ .url_pattern_label , p);
        for(i = 0; cfg.condition.url_pattern && cfg.condition.url_pattern[i] ; i++)
                _free(cfg.condition.url_pattern[i]);\
        _free(cfg.condition.url_pattern);
        cfg.condition.url_pattern = make_list(p , ",");
	_free(p);

        p = NULL;
        GET_STR(cfg. _IFT_ .skip_url_pattern , p);
        for(i = 0; cfg.condition.skip_url_pattern && cfg.condition.skip_url_pattern[i] ; i++)
                _free(cfg.condition.skip_url_pattern[i]);\
        _free(cfg.condition.skip_url_pattern);
        cfg.condition.skip_url_pattern = make_list(p , ",");
	_free(p);

        GET_STR(cfg. _IFT_ .en_uexit , cfg.condition.uexit);

	GET_LIST(cfg. _IFT_ .hosts_list , cfg.condition.sites);

	GET_LIST(cfg. _IFT_ .amimelist , cfg.condition.mime);

	GET_LIST(cfg. _IFT_ .domain_list , cfg.condition.domains);

	GET_NUM(cfg. _IFT_ .maxlev_label , cfg.condition.max_levels);

	GET_NUM(cfg. _IFT_ .leave_level , cfg.condition.leave_level);

	GET_NUM(cfg. _IFT_ .maxdoc_label , cfg.condition.max_documents);

	GET_NUM(cfg. _IFT_ .maxsize_label , cfg.condition.max_size);
	GET_NUM(cfg. _IFT_ .min_size , cfg.condition.min_size);

	GET_LIST(cfg. _IFT_ .sufixlist , cfg.condition.sufix);	

	GET_LIST(cfg. _IFT_ .prefixlist , cfg.condition.dir_prefix);

	GET_BOOL(cfg. _IFT_ .btime_sw , b);
	if (b)
	{
		GET_DATE(cfg. _IFT_ .btime_cal  , ftm);
		ftm.tm_sec = 0;
		ftm.tm_isdst = -1;
		GET_NUM(cfg. _IFT_ .btime_h_entry , ftm.tm_hour);
		GET_NUM(cfg. _IFT_ .btime_min_entry , ftm.tm_min);
		cfg.condition.btime = mktime(&ftm);
	}
	
	else cfg.condition.btime = (time_t)0;

	GET_BOOL(cfg. _IFT_ .etime_sw , b);
	if (b)
	{
		GET_DATE(cfg. _IFT_ .etime_cal  , ftm);
		ftm.tm_sec = 0;
		ftm.tm_isdst = -1;
		GET_NUM(cfg. _IFT_ .etime_h_entry , ftm.tm_hour);
		GET_NUM(cfg. _IFT_ .etime_min_entry , ftm.tm_min);
		cfg.condition.etime = mktime(&ftm);
	}
	else cfg.condition.etime = (time_t)0;

	return 0;
}

int xget_cfg_values_comm()
{
	char *p = NULL;
	struct stat estat;

	GET_STR(cfg. _IFT_ .cdir_label , p);
	if (p && !((stat(p , &estat) >= 0) && S_ISDIR(estat.st_mode)))
	{
		xprintf(0 , gettext("Bad parameter - Cache directory"));
		return -1;
	}
	else
	{
		_free(cfg.cache_dir);
		if (p) cfg.cache_dir = get_abs_file_path(p);
		_free(p);
	}


	p = cfg.auth_file;
	GET_S_STR(cfg. _IFT_ .auth_file_label , cfg.auth_file);
	if (!((cfg.auth_file && p && !strcmp(p , cfg.auth_file)) || !cfg.auth_file))
		authinfo_load(cfg.auth_file);
	_free(p);

	p = cfg.cookie_file;
	GET_S_STR (cfg. _IFT_ .en_cookie_file , cfg.cookie_file);
	if (!((cfg.cookie_file && p && !strcmp(p , cfg.cookie_file)) || !cfg.cookie_file))
	{
		cookie_free_all(cfg.cookies);
		cfg.cookies = cookie_read_ns(cfg.cookie_file);
		cfg.last_cookie = cookie_get_last_entry(cfg.cookies , &cfg.cookies_num);
	}
	_free(p);

	GET_BOOL(cfg. _IFT_ .check_size , cfg.check_size);
	GET_BOOL(cfg. _IFT_ .store_index , cfg.store_index);

	GET_BOOL(cfg. _IFT_ .preserve_perm , cfg.preserve_perm);
	GET_BOOL(cfg. _IFT_ .preserve_links , cfg.preserve_links);
	GET_BOOL(cfg. _IFT_ .ftp_list , cfg.ftp_list);

	GET_STR (cfg. _IFT_ .index_name , cfg.index_name);
	GET_STR (cfg. _IFT_ .store_name , cfg.store_name);

	GET_BOOL(cfg. _IFT_ .sw_cookie_send , cfg.send_cookies);
	GET_BOOL(cfg. _IFT_ .sw_cookie_recv , cfg.recv_cookies);
	GET_BOOL(cfg. _IFT_ .sw_cookie_update , cfg.update_cookies);

	GET_BOOL(cfg. _IFT_ .ptime , cfg.preserve_time);

	GET_BOOL(cfg. _IFT_ .cache_sw , cfg.cache);

	GET_BOOL(cfg. _IFT_ .oldrm_sw , cfg.remove_old);

	GET_BOOL(cfg. _IFT_ .ftp_sw , cfg.condition.ftp);


	GET_BOOL(cfg. _IFT_ .http_sw , cfg.condition.http);

#ifdef USE_SSL
	GET_BOOL(cfg. _IFT_ .https_sw , cfg.condition.https);
#endif
	GET_BOOL(cfg. _IFT_ .gopher_sw , cfg.condition.gopher);

	GET_BOOL(cfg. _IFT_ .gopher_httpgw , cfg.gopher_via_http);

	GET_BOOL(cfg. _IFT_ .ftp_httpgw , cfg.ftp_via_http);

	GET_BOOL(cfg. _IFT_ .ftp_dirtyp , cfg.ftp_dirtyp);

	GET_BOOL(cfg. _IFT_ .freget_sw , cfg.freget);

	GET_BOOL(cfg. _IFT_ .noreloc_sw , cfg.rewrite_links);

	GET_BOOL(cfg. _IFT_ .enc_sw , cfg.use_enc);

	GET_BOOL(cfg. _IFT_ .auth_reuse_nonce , cfg.auth_reuse_nonce);
	GET_BOOL(cfg. _IFT_ .auth_reuse_proxy_nonce , cfg.auth_reuse_proxy_nonce);

	GET_C_EXTRAS;

#ifdef WITH_TREE
	GET_STR(cfg. _IFT_ .browser_label , cfg.browser);
#endif

	GET_STR(cfg. _IFT_ .identity , cfg.identity);

	GET_STR(cfg. _IFT_ .http_proxyh_label , cfg.http_proxy);

	GET_NUM(cfg. _IFT_ .http_proxyp_label , cfg.http_proxy_port);

	GET_STR(cfg. _IFT_ .ftp_proxyh_label , cfg.ftp_proxy);

	GET_NUM(cfg. _IFT_ .ftp_proxyp_label , cfg.ftp_proxy_port);

	GET_STR(cfg. _IFT_ .gopher_proxyh_label , cfg.gopher_proxy);

	GET_NUM(cfg. _IFT_ .gopher_proxyp_label , cfg.gopher_proxy_port);

#ifdef USE_SSL
	GET_STR(cfg. _IFT_ .ssl_proxyh_label , cfg.ssl_proxy);

	GET_NUM(cfg. _IFT_ .ssl_proxyp_label , cfg.ssl_proxy_port);

	GET_STR (cfg. _IFT_ .ssl_cert_file_en , cfg.ssl_cert_file);
	GET_STR (cfg. _IFT_ .ssl_key_file_en , cfg.ssl_key_file);
	GET_STR (cfg. _IFT_ .ssl_cert_passwd_en , cfg.ssl_cert_passwd);
#endif
	GET_NUM(cfg. _IFT_ .en_cookie_max , cfg.cookies_max);

	GET_NUM(cfg. _IFT_ .base_level_label , cfg.base_level);

	GET_NUM(cfg. _IFT_ .timeout_label , cfg.ctimeout);

	GET_NUM(cfg. _IFT_ .retry_label , cfg.nretry);

	GET_NUM(cfg. _IFT_ .redir_label , cfg.nredir);

	GET_NUM(cfg. _IFT_ .reget_label , cfg.nreget);

	GET_NUM(cfg. _IFT_ .sleep_label , cfg.sleep);

	GET_NUM(cfg. _IFT_ .xloglen_label , cfg.xlogsize);

/****/
	GET_STR(cfg. _IFT_ .slog_label , cfg.short_logfile);

	p = cfg.logfile;
	GET_S_STR(cfg. _IFT_ .log_label , cfg.logfile);
	if (cfg.logfd >= 0)
	{
		if ((cfg.logfile && strcmp(p,cfg.logfile)) || !cfg.logfile)
		{
			close(cfg.logfd);
			cfg.logfd = -1;
		}
	}
	_free(p);
	 if (cfg.logfile && cfg.logfd < 0)
	 {
	 	if ((cfg.logfd = open(cfg.logfile , O_BINARY | O_CREAT | O_APPEND | O_WRONLY , 0666)) < 0)
	 	{
	 		xperror(cfg.logfile);
	 	}
	 }
/****/

	GET_STR(cfg. _IFT_ .auth_label , cfg.name_auth);

	GET_STR(cfg. _IFT_ .pass_label , cfg.passwd_auth);

	GET_STR(cfg. _IFT_ .proxy_auth_label , cfg.http_proxy_user);

	GET_STR(cfg. _IFT_ .proxy_pass_label , cfg.http_proxy_pass);	

	GET_BOOL(cfg. _IFT_ .send_from , cfg.send_from);
	GET_STR(cfg. _IFT_ .from_label , cfg.from);

	GET_NUM(cfg. _IFT_ .rollback_label , cfg.rollback);

	GET_NUM(cfg. _IFT_ .ddays_label , cfg.ddays);

	GET_LIST(cfg. _IFT_ .langlist , cfg.accept_lang);

	GET_DLLIST(cfg. _IFT_ .url_list , cfg.prepurlstr);

	GET_LIST(cfg. _IFT_ .cookie_domain_list , cfg.cookies_disabled_domains);

	GET_STR(cfg. _IFT_ .tr_del_chr , cfg.tr_del_chr);
	GET_STR(cfg. _IFT_ .tr_str_s1 , cfg.tr_str_s1);
	GET_STR(cfg. _IFT_ .tr_str_s2 , cfg.tr_str_s2);
	GET_STR(cfg. _IFT_ .tr_chr_s1 , cfg.tr_chr_s1);
	GET_STR(cfg. _IFT_ .tr_chr_s2 , cfg.tr_chr_s2);

	return 0;
}

#endif /* I_FACE */

