/***************************************************************************/
/* 		This code is part of WWW graber called pavuk		   */
/*		Copyright (c) 1997,1998,1999 Ondrejicka Stefan		   */
/*		(ondrej@idata.sk)					   */
/*		Distributed under GPL 2 or later			   */
/***************************************************************************/

#ifndef _xinterface_h_
#define _xinterface_h_

#ifdef X_FACE
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <Nws/Nws.h>

#include "tools.h"

#define iface_load_xpm_icon(xpm_name) X_XpmDataToIcon(cfg.X.dpy , xpm_name)

/**** makro na obsluhu udalosti z rozhrania X-windows ****/
#ifndef _Xt_Serve
#define _Xt_Serve \
	if (cfg.xi_face)\
	{\
		while (XtAppPending(cfg.X.app_context))\
		{\
			XEvent event;\
			XtAppNextEvent(cfg.X.app_context , &event);\
			XtDispatchEvent(&event);\
		}\
	}
#endif


#ifndef _Xt_ServeLoop
#define _Xt_ServeLoop \
	if (cfg.xi_face)\
	{\
		cfg.X.endloop = FALSE;\
		while (!cfg.X.endloop && !cfg.rbreak)\
		{\
			XEvent event;\
			XtAppNextEvent(cfg.X.app_context , &event);\
			XtDispatchEvent(&event);\
		}\
	}
#endif
			
#ifndef _X_EscLoop
#define _X_EscLoop()\
{\
	static XEvent event;\
\
	cfg.X.endloop = TRUE;\
	event.xexpose.type = Expose;\
	event.xexpose.count = 0;\
	event.xexpose.display = cfg.X.dpy;\
	event.xexpose.window = XtWindow(cfg.X.what_widget);\
\
	XSendEvent(cfg.X.dpy , XtWindow(cfg.X.what_widget) ,\
		False , ExposureMask , &event);\
}
#endif

#define GUI_TREE_RTYPE TreeList*

typedef struct _xinfo {
	Widget		charset_list;
	Widget		acharset_list;
	Widget		acharset_entry;
	Widget		identity;
	Widget		store_index;
	Widget		send_from;
	Widget		check_size;
	Widget		min_size;
	Widget		skip_pattern;
	Widget		skip_url_pattern;
	Widget		ftp_html;
	Widget		preserve_perm;
	Widget		preserve_links;
	Widget		ftp_list;
	Widget		index_name;
	Widget		store_name;
	Widget		tr_del_chr;
	Widget		tr_str_s1;
	Widget		tr_str_s2;
	Widget		tr_chr_s1;
	Widget		tr_chr_s2;
	Widget		en_uexit;
	Widget		html_tags;
	Widget		cookie_domain_list;
	Widget		cookie_domain_entry;
	Widget		sw_cookie_update;
	Widget		sw_cookie_recv;
	Widget		sw_cookie_send;
	Widget		en_cookie_file;
	Widget		en_cookie_max;
	Widget		cb_comcfg;
	Widget		leave_level;
	Widget		resched;
	Widget		leaved_sw;
	Widget		leaves_sw;
	Widget		ptime;
	Widget		btime_cal;
	Widget		etime_cal;
	Widget		btime_yentry;
	Widget		etime_yentry;
	Widget		btime_h_entry;
	Widget		etime_h_entry;
	Widget		btime_min_entry;
	Widget		etime_min_entry;
	Widget		btime_mon;
	Widget		etime_mon;
	Widget		btime_sw;
	Widget		etime_sw;
	bool		endloop;	/*** escape from _Xt_Serve loop ***/
	Widget		toplevel;	/*** jednotlive widgety ktore potrebujeme adresovat ***/
	ToggleGroup	*modegr;	/*** toggle group for mode selection ***/
	Widget		logw;
	Widget		scn_load_shell;
	Widget		scn_lme;
	Widget		scn_lfs;
	Widget		scn_save_shell;
	Widget		scn_sme;
	Widget		scn_sfs;
	Widget		log_label;
	Widget		slog_label;
	Widget		auth_file_label;
	Widget		base_level_label;
	Widget		xloglen_label;
	Widget		maxdoc_label;
	Widget		maxlev_label;
	Widget		maxsize_label;
	Widget		browser_label;
	Widget		ddays_label;
	Widget		rollback_label;
	Widget		oldrm_sw;
	Widget		mime_sw;
	Widget		freget_sw;
	Widget		noreloc_sw;
	Widget		gopher_sw;
	Widget		ftp_sw;
	Widget		ftpd_sw;
	Widget		ftp_data_sw;
	Widget		http_sw;
	Widget		https_sw;
	Widget		cache_sw;
	Widget		cgi_sw;
	Widget		robots_sw;
	Widget		enc_sw;
	Widget		auth_sw;
	Widget		url_entry;
	Widget		url_list;
	Widget		cdir_label;
	Widget		http_proxyh_label;
	Widget		http_proxyp_label;
#ifdef USE_SSL
	Widget		ssl_proxyh_label;
	Widget		ssl_proxyp_label;
	Widget		ssl_key_file_en;
	Widget		ssl_cert_file_en;
	Widget		ssl_cert_passwd_en;
#endif
	Widget		ftp_proxyh_label;
	Widget		ftp_proxyp_label;
	Widget		ftp_httpgw;
	Widget		ftp_dirtyp;
	Widget		gopher_proxyh_label;
	Widget		gopher_proxyp_label;
	Widget		gopher_httpgw;
	Widget		retry_label;
	Widget		redir_label;
	Widget		reget_label;
	Widget		hour_label;
	Widget		min_label;
	Widget		auth_label;
	Widget		pass_label;
	Widget		auth_reuse_nonce;
	Widget		proxy_auth_label;
	Widget		proxy_pass_label;
	Widget		auth_reuse_proxy_nonce;
	Widget		proxy_auth_sw;
	Widget		from_label;
	Widget		subdir_label;
	Widget		timeout_label;
	Widget		config_shell;
	Widget		about_shell;
	Widget		calendar;
	Widget		month;
	Widget		year;
	Widget		what_widget;	
	Widget		cnt_widget;
	Widget		size_widget;
	Widget		langlist;
	Widget		alanglist;
	Widget		alang_entry;
	Widget		mimelist;
	Widget		amimelist;
	Widget		mimet_entry;
	Widget		prefixlist;
	Widget		prefix_label;
	Widget		prefix_sw;
	Widget		sufixlist;
	Widget		sufix_label;
	Widget		sufix_sw;
	Widget		domain_sw;
	Widget		domain_list;
	Widget		domain_entry;
	Widget		hosts_sw;
	Widget		hosts_list;
	Widget		hosts_entry;
	Widget		pattern_label;
	Widget		url_pattern_label;
	Widget		sleep_label;
	Widget		cfg_sch;
	Widget		cfg_limits;
	Widget		mbb_cfg;
	Widget		mbb_mode;
	Widget		bt_cfg;
	Widget		bt_bg;
	Widget		bt_rest;
	Widget		bt_start;
	Widget		bt_stop;
	Widget		bt_break;
	Widget		bt_exit;
	Widget		mea_rest;
	Widget		mea_start;
	Widget		mea_stop;
	Widget		mea_break;
	Widget		me_surl;
	Widget		me_sch;
	XtAppContext	app_context;
	Display	*dpy;
	XtInputId 	iid;		/*** identifikator funkcie spatneho volania ktora ma na starosti citanie ***/
	XtIntervalId	inid;		/*** timeout ID for reading ***/
#ifdef WITH_TREE
	TreeList	*root;		/*** struktara v ktorej sa udrzuje graficka reprezentacia stromu dokumentov ***/
	Widget		me_tree;
	Widget		tree_widget;
	Widget		tree_shell;
	Widget		tree_help;
	Widget		tmenu;
	Widget		me_disable_url;
	Widget		me_enable_url;
	Widget		me_download_url;
	Widget		me_browse_url;
	Widget		me_prop_url;
	Widget		me_debug;
	Widget		me_quiet;
#endif
} Xnfo;

extern void iface_loop();
extern void build_interface();
extern void iface_set_counter();
extern void iface_set_what();
extern void iface_set_size();
extern void iface_url_set_icon();
extern GUI_TREE_RTYPE iface_make_tree_entry();
#define iface_set_url(url)

#endif

#endif
